unit Cow_F;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, RXCtrls, ToolWin, StdCtrls, Buttons, ExtCtrls,ShellApi,
  RxGIF, IniFiles, CPort, DB, DBTables, CPortCtl;

const
  CMD_STATE      = $61;  // 'a'  - ſ Ȯ
  CMD_LIMIT      = $62;  // 'b'  - Ʈ  
  CMD_READER     = $63;  // 'c'  - ˿
  CMD_LAMP       = $64;
  CMD_ERROR      = $65;

  ID_CONTROLLER  = $30;
  ID_READER      = $31;
  ID_LIMIT       = $32;
  ID_LAMP        = $33;

  LP_OFF         = $30;  // Lamp Off
  LP_RED         = $31;  // RED
  LP_BLUE        = $32;  // BLUE
  LP_ALL         = $33;  //   ON

  LIMIT_ON       = $31;  // '1'

  _STX           = $02;
  _ETX           = $03;
  _ACK           = $06;
  _NAK           = $15;

  MAX_SIZE       = 1024;

type
  TfrmCow_F = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    dtdate: TDateTimePicker;
    Image1: TImage;
    Image2: TImage;
    Panel7: TPanel;
    btn1: TButton;
    pnMsg1: TPanel;
    pnMsg2: TPanel;
    PnMsg3: TPanel;
    btn2: TButton;
    btn3: TButton;
    btn4: TButton;
    btn5: TButton;
    btn6: TButton;
    btn7: TButton;
    btn8: TButton;
    btn9: TButton;
    btn0: TButton;
    pnNo: TPanel;
    pnJiNo: TPanel;
    CmPt: TComPort;
    QryTemp: TQuery;
    QryTemp1: TQuery;
    tmConnect: TTimer;
    Panel11: TPanel;
    pnstno: TPanel;
    Panel13: TPanel;
    pnedno: TPanel;
    Panel12: TPanel;
    edLTagNo: TEdit;
    Panel8: TPanel;
    Panel9: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    btnSav: TButton;
    btnSch: TButton;
    btnClr: TButton;
    btnExt: TButton;
    Panel16: TPanel;
    Panel17: TPanel;
    PnPum: TPanel;
    btnPum: TButton;
    PnSex: TPanel;
    Panel20: TPanel;
    PnLr: TPanel;
    btnSex: TButton;
    btnLr: TButton;
    tmLamp: TTimer;
    Shape1: TShape;
    edrTagno: TEdit;
    pnMsg4: TPanel;
    procedure btnExtClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ClearScreen;
    procedure FormCreate(Sender: TObject);
    procedure btn1Click(Sender: TObject);
    procedure pnNoClick(Sender: TObject);
    procedure pnJiNoClick(Sender: TObject);
    procedure btnClrClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image2Click(Sender: TObject);
    procedure btnSchClick(Sender: TObject);
    procedure btnSavClick(Sender: TObject);
    procedure InsertAucTag;
    procedure InsertAucLogTag;

    function  PortChk : Boolean;
    function  GetTotalCnt : Integer;
    function  GetInputCnt : Integer;
    function  GetMinMaxRvNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String) :boolean;

    function  AucTagGetExMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                      in_IMtNo: Integer) : Boolean;
    function  LeftRightCheck(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                      in_IMtNo: Integer) : String;

    function  getCommon(in_main_cd, in_sub_cd : String) : String;
    procedure btnLrClick(Sender: TObject);

    function  GetRvMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                           in_iMtNo : Integer) : boolean;

    function  GetMaxRvNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String) : boolean;


    procedure DataExCheck;
    procedure SerialInit;
    procedure CmPtRxChar(Sender: TObject; Count: Integer);
    procedure tmConnectTimer(Sender: TObject);
    procedure tmLampTimer(Sender: TObject);
    procedure btnPumClick(Sender: TObject);
    procedure btnSexClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure dtdateChange(Sender: TObject);
    procedure Panel12Exit(Sender: TObject);
    procedure Panel12DblClick(Sender: TObject);

  private
    { Private declarations }
    pBuf: array[0..MAX_SIZE-1] of Byte;
    pIdx: Integer;
    TimeCnt : DWord;

  public
    { Public declarations }
    procedure NotificationHandler(buf: array of byte; cnt: Integer);
    function SendPacket(cmd: byte; id: byte; buf:array of byte; len: Integer): Integer;

    function ArrayToString(buf:array of byte; len:Integer): string;

  end;

var
  frmCow_F: TfrmCow_F;

implementation

uses DM_F, Setup, TchLib;

Var IptFlag, InsertFlag : Boolean;
  sPort, sRate, sOnCd, sTagNo, sLtag, sRtag  : String;
  pbDate, sAnCd, sLrGb, sKnd_cd, sSex_Cd, sErr_Text : String;
  iMtNo, iWorkCnt, iTotalCnt, iLampTime : integer;
  iMinRvNo, iMaxRvNo, iRvNo, iClickCnt : Integer;

{$R *.dfm}

procedure TfrmCow_F.btnExtClick(Sender: TObject);
begin
  If Application.MessageBox('Ͻðڽϱ?', '',MB_YESNO) = IDYES then begin
     CmPt.Close;
     Close;
  end;
end;

procedure TfrmCow_F.FormKeyPress(Sender: TObject; var Key: Char);
begin
   If (Key = #13) Then
   Begin
      Key := #0;
      PerForm(WM_NEXTDLGCTL, 0, 0);
   End;
end;

procedure TfrmCow_F.ClearScreen;
begin
  IptFlag          := True;
//  PnNo.Caption     := '';
  PnNo.Color       := ClWhite;
  PnJiNo.Color     := $006FE6B0;
//  PnJiNo.Caption   := '';
  PnMsg3.Font.Color := clBlue;
  PnMsg3.Caption   := '';
  PnMsg4.Font.Color := clBlue;
  PnMsg4.Caption   := '´';
  sKnd_cd          := '11';
  PnPum.Caption    := 'ѿ';
  sSex_Cd          := '1';
  PnSex.Caption    := '';
  sLrGb            := '1';
  PnLr.Caption     := '';
  PnLr.Font.Color  := clBlue;
  btnPum.Enabled   := True;
  btnSex.Enabled   := True;
  sTagNo           := '';
  sLtag            := '';
  sRtag            := '';
  edLTagNo.Text    := '';
  edRTagNo.Text    := '';
end;

procedure TfrmCow_F.FormCreate(Sender: TObject);
var
  sLr_Gb : String;
begin
  iMtNo     := 0;   //  ʱȭ
  iRvNo     := 0;
  iTotalCnt := 0;   // ü ۾ 
  iWorkCnt  := 0;   //  ۾  
  iMinRvNo  := 0; iMaxRvNo := 0;
  iClickCnt := 0;
  edlTagNo.Text := '';
  edRtagNo.Text := '';
  sAnCd     := '1';
  sLtag     := '';
  sRtag     := '';
  sLrGb     := '1';
  PnLr.Caption := '';
  PnLr.Font.Color  := clBlue;

  InsertFlag := True;
  TmConnect.Enabled := false;
  TmLamp.Enabled := false;

  ClearScreen;
  btnPum.Enabled   := False;
  btnSex.Enabled   := False;

  DateTimeToString(pbDate, 'YYYY-MM-DD', gdDate);

  DtDate.Date      := StrToDateTime(pbDate);

 //  αν Ʈ üũ
  If PortChk = False then begin  // Ʈ    Setup ȭ Display
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
  end;

  iTotalCnt := GetTotalCnt;
  iWorkCnt  := GetInputCnt;
  PnMsg2.Caption := ' : ' + IntToStr(iTotalCnt - iWorkCnt);
  PnMsg1.Caption := ' : ' + IntToStr(iWorkCnt);

  if GetMaxRvNo(sOnCd, pbDate, sAnCd) = true then begin
    if GetRvMtNo(sOnCd, pbDate, sAnCd, iMtNo) = true then begin
      PnNo.Caption   := IntToStr(iRvNo);
      PnJiNo.Caption := IntToStr(iMtNo);
    end
    else begin
      ShowMessage(' ȣ ۾ ϷǾ!');
      PnNo.Caption := IntToStr(iRvNo);
    end;
  end
  else begin
    if GetRvMtNo(sOnCd, pbDate, sAnCd, iMtNo) = true then begin
      PnNo.Caption   := IntToStr(iRvNo);
      PnJiNo.Caption := IntToStr(iMtNo);
    end
    else begin
      ShowMessage('ڷᰡ ϴ! ȮϽʽÿ!');
    end;
  end;

  if GetMinMaxRvNo(sOnCd, pbDate, sAnCd) = true then begin
    PnStNo.Caption := IntToStr(iMinRvNo);
    PnEdNo.Caption := IntToStr(iMaxRvNo);
  end
  else begin
    PnStNo.Caption := '0';
    PnEdNo.Caption := '0';
  end;

  SerialInit;
end;

Function TfrmCow_F.PortChk : Boolean;
Var MyIni : TIniFile;
    sSysPath : String;
Begin
  CmPt.Open;
  if Not CmPt.Connected then
     result := false
  else
     result := true;

  sSysPath := GetCurrentDir + '\Setup.ini';
  MyIni := TIniFile.Create(sSysPath);
  If FileExists(sSysPath) = False Then Begin
     Result := false;
     Exit;
  end
  else begin
    sPort := MyIni.ReadString('ȯ漳', 'PORT', '');
    sRate := MyIni.ReadString('ȯ漳', 'SPEED', '');
    sOnCd  := MyIni.ReadString('ȯ漳', 'ONLINECODE', '');
    iLampTime := MyIni.ReadInteger('ȯ漳', 'LAMP', 0);
  // Ʈѷ Ʈ  üũ
    Case StrToInt(sPort) Of     // Ʈѷ Ʈȣ
      0 : begin
            CmPt.Port := 'COM1';
          end;
      1 : begin
            CmPt.Port := 'COM2';
          end;
      2 : begin
            CmPt.Port := 'COM3';
          end;
      3 : begin
            CmPt.Port := 'COM4';
          end;
    End;

    Case StrToInt(sRate) Of   // ѷ Ʈӵ
       0 : begin
             CmPt.BaudRate      := br2400;
           end;
       1 : begin
             CmPt.BaudRate      := br4800;
           end;
       2 : begin
             CmPt.BaudRate      := br9600;
           end;
       3 : begin
             CmPt.BaudRate      := br14400;
           end;
       4 : begin
             CmPt.BaudRate      := br19200;
           end;
       5 : begin
             CmPt.BaudRate      := br38400;
           end;
       6 : begin
             CmPt.BaudRate      := br56000;
           end;
    End;
  end;
End;

procedure TfrmCow_F.btn1Click(Sender: TObject);
begin
  if IptFlag = True Then Begin
    PnJiNO.Caption := PnJiNo.Caption + (Sender As TButton).Caption;
    if Length(PnJiNo.Caption) > 4 then begin
      ShowMessage('ϵ ȣ ʰ!');
      PnJiNo.Caption := Copy(PnJiNo.Caption, 0, 4);
    end;
  End
  Else Begin
    PnNo.Caption := PnNo.Caption + (Sender As TButton).Caption;
    If Length(PnNo.Caption) > 4 Then begin
      ShowMessage('ϵ ȣʰ!');
      PnNo.Caption := copy(PnNo.Caption, 0, 4);
    end;
  end;
end;

procedure TfrmCow_F.pnNoClick(Sender: TObject);
begin
  IptFlag := False;
  PnNo.Caption := '';
  PnNo.Color := $006FE6B0;
  PnJiNo.Color := ClWhite;
end;

procedure TfrmCow_F.pnJiNoClick(Sender: TObject);
begin
  IptFlag := True;
  PnJiNo.Caption := '';
  PnNo.Color := ClWhite;
  PnJiNo.Color := $006FE6B0;
end;

procedure TfrmCow_F.btnClrClick(Sender: TObject);
begin
  ClearScreen;
  btnSav.Enabled := True;
end;

procedure TfrmCow_F.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   If (Shift = [ssShift, ssAlt]) and (Key = VK_F1) Then
   Begin
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
   End;

   If PortChk = False then begin  // Ʈ    Setup ȭ Display
      frmSetup := TfrmSetup.Create(Application);
      frmSetup.ShowModal;
   end;
end;

procedure TfrmCow_F.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CmPt.Close;
  Action := CaFree;
end;

procedure TfrmCow_F.btnLrClick(Sender: TObject);
begin
  if sLrGb = '1' then begin
     sLrGb := '2';
     PnLr.Caption := '';
     PnLr.Font.Color := clRed;
  end
  else begin
     sLrGb := '1';
     PnLr.Caption := '';
     PnLr.Font.Color := clBlue;
  end;
end;

procedure TfrmCow_F.Image2Click(Sender: TObject);
begin
  If PnNo.Caption = '0000' then begin
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
  end;

  If PortChk = False then begin  // Ʈ    Setup ȭ Display
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
  end;
end;

Function TfrmCow_F.GetTotalCnt : Integer;
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select count(distinct mt_no) cnt from aucmeat ' +
            '  where online_cd = :oncd                  ' +
            '    and kill_ymd  = :ymd                   ' +
            '    and animal_cd = :ancd                  ' +
            '    and mt_no     < 8000                   ' +
            '    and io_gb     <> ''32''                ');
    ParamByName('oncd').AsInteger := StrToInt(sOnCd);
    ParamByName('ymd').AsString   := sDate;
    ParamByName('ancd').AsString  := sAnCd;
    Open;
    if Not Eof then
       Result := FieldByName('cnt').AsInteger
    else Result := 0;
    close;
  end;
end;

Function TfrmCow_F.GetInPutCnt : Integer;
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select count(distinct mt_no) cnt from auctag ' +
            '  where online_cd = :oncd                  ' +
            '    and kill_ymd  = :ymd                   ' +
            '    and animal_cd = :ancd                  ' +
            '    and mt_no     < 8000                    ');
    ParamByName('oncd').AsInteger := StrToInt(sOnCd);
    ParamByName('ymd').AsString   := sDate;
    ParamByName('ancd').AsString  := sAnCd;
    Open;
    if Not Eof then
       Result := FieldByName('cnt').AsInteger
    else Result := 0;
    close;
  end;
end;

function TfrmCow_F.GetMinMaxRvNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String) : boolean;
begin
  With QryTemp Do Begin
    Close;
    Sql.Clear;
    Sql.Add(' select min(receive_no) min_rv_no,           ' +
            '        max(receive_no) max_rv_no            ' +
            '   from aucmeat                              ' +
            '  where online_cd = :oncd                    ' +
            '    and kill_ymd  = :ymd                     ' +
            '    and animal_cd = :sAnCd                   ' +
            '    and mt_no     < 8000                     ' +
            '    and io_gb     <> ''32''                  ');
    ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd').AsString   := in_Kill_Ymd;
    ParamByName('sAnCd').AsString := In_sAnCd;
    Open;
    if Not eof then begin
      iMinRvNo := FieldByName('min_rv_no').AsInteger;
      iMaxRvNo := FieldByName('max_rv_no').AsInteger;
      Result := True;
    end
    else begin
      iMinRvNo := 0;
      iMaxRvNo := 0;
      Result := False;
    end;
    close;
  end;
end;

// ȣ ǳʶٰ   ٽ ó   ϵ ڷ Check ϱ
function TfrmCow_F.AucTagGetExMtNo(in_sOnCd, in_Kill_Ymd, In_sAnCd : String;
                                   in_IMtNo : Integer) : Boolean;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select receive_no, mt_no           ' +
            '   from auctag                      ' +
            '  where online_cd = :sOnCd          ' +
            '    and kill_ymd  = :ymd            ' +
            '    and animal_cd = :ancd           ' +
            '    and mt_no      = :mtno          ' );
    ParamByName('sOnCd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd'  ).AsString  := in_Kill_Ymd;
    ParamByName('ancd' ).AsString  := in_sAnCd;
    ParamByName('mtno' ).AsInteger := in_IMtNo;
    Open;
    if not eof then begin
      iRvNo := FieldByName('receive_no').AsInteger;
      iMtNo  := FieldByName('mt_no').AsInteger;
      Result := true;
    end
    else begin
      iMtNo := iMtNo;
      Result := False;
    end;     // if  end
    close;
  end;       // with qrytemp end
end;

function TfrmCow_F.LeftRightCheck(in_sOnCd, in_kill_ymd, in_sAnCd : String;
                                  in_iMtNo : integer) : String;
begin
  with QryTemp do begin   // ¿  
    Close;
    Sql.Clear;
    Sql.Add(' select (select lr_gb from auctag a              ' +
            '        where online_cd = :oncd                  ' +
            '          and kill_ymd  = :ymd                   ' +
            '          and animal_cd = :ancd                  ' +
            '          and  mt_no    = :mtno                  ' +
            '          and lr_gb     = ''1'') lrgb1,          ' +
            '      (select lr_gb from auctag b                ' +
            '        where online_cd = :oncd                  ' +
            '          and kill_ymd  = :ymd                   ' +
            '          and animal_cd = :ancd                  ' +
            '          and  mt_no     = :mtno                 ' +
            '          and lr_gb      = ''2'') lrgb2          ' +
            '         from auctag c                           ' +
            '        where online_cd = :oncd                  ' +
            '          and kill_ymd  = :ymd                   ' +
            '          and animal_cd = :ancd                  ' +
            '          and  mt_no     = :mtno                 ' +
            '         group by mt_no, animal_cd, receive_no   ');
    ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd' ).AsString  := in_Kill_Ymd;
    ParamByName('ancd').AsString  := in_sAnCd;
    ParamByName('mtno').AsInteger := iMtNo;
    Open;
    if ((FieldByName('lrgb1').AsString = '1') and
       (FieldByName('lrgb2').AsString <> '2')) then begin
       Result := FieldByName('lrgb1').AsString;
    end
    else if ((FieldByName('lrgb1').AsString <> '1') and
             (FieldByName('lrgb2').AsString = '2')) then begin
       result := FieldByName('lrgb2').AsString;
    end
    else if ((FieldByName('lrgb1').AsString = '1') and
             (FieldByName('lrgb2').AsString = '2')) then begin
      Result := '3';
    end
    else begin
      Result := '4';
    end;
    close;
  end;
end;

function TfrmCow_F.GetRvMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                           in_iMtNo : Integer) : boolean;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add('select a.receive_no rvno, a.mt_no mtno   ' +
            '  from aucmeat a                         ' +
            ' where online_cd  = :OnCd                ' +
            '   and kill_ymd   = :ymd                 ' +
            '   and mt_no      < 8000                 ' +
            '   and mt_no      >= :mtno               ' +
            '   and mt_no not in                      ' +
            '       (select mt_no                     ' +
            '          from auctag                    ' +
            '         where online_cd  = a.online_cd  ' +
            '           and kill_ymd   = a.kill_ymd   ' +
//            '           and receive_no = a.receive_no ' +
            '           and mt_no      = a.mt_no      ' +
            '           and animal_cd  = a.animal_cd )' +
            '   and animal_cd =  :ancd                ' +
            '   and io_gb     <> ''32''               ' +
            ' group by a.receive_no, a.mt_no          ' +
            ' order by receive_no, a.mt_no            ');
    ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd' ).AsString  := in_kill_ymd;
    ParamByName('ancd').AsString  := in_sAnCd;
    ParamByName('mtno').AsInteger := in_iMtNo;
    Open;
    First;
    if Not Eof then begin
      iRvNo := FieldByName('rvno').AsInteger;
      iMtNo := FieldByName('mtno').AsInteger;
      Result := True;
      with QryTemp1 do begin
        Close;
        Sql.Clear;
        Sql.Add(' select receive_no, kind_cd, sex_cd  from aucmeat        ' +
                '  where online_cd = :oncd                    ' +
                '    and kill_ymd  = :ymd                     ' +
                '    and animal_cd = :ancd                    ' +
                '    and mt_no     = :mtno                    ');
        ParamByName('oncd').AsInteger := StrToInt(sOnCd);
        ParamByName('ymd').AsString   := in_kill_ymd;
        ParamByName('ancd').AsString  := in_sAnCd;
        ParamByName('mtno').AsInteger  := iMtNo;
        Open;
        if Not Eof then begin
           sKnd_Cd := FieldByName('kind_cd').AsString;
           sSex_Cd := FieldByName('sex_cd' ).AsString;
           PnPum.Caption := getCommon('18', sKnd_Cd);
           PnSex.Caption := getCommon('12', sSex_Cd);
        end;
        close;
      end;
    end
    else begin
      Result := False;
    end;
    close;
  end;
end;

function TfrmCow_F.GetMaxRvNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String) : boolean;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add('select max(mt_no) mtno                   ' +
            '  from auctag                            ' +
            ' where online_cd  = :OnCd                ' +
            '   and kill_ymd   = :ymd                 ' +
            '   and animal_cd =  :ancd                ');
    ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd' ).AsString  := in_kill_ymd;
    ParamByName('ancd').AsString  := in_sAnCd;
    Open;
    if FieldByName('mtno').AsInteger > 0 then begin
      iRvNo := FieldByName('mtno').AsInteger;
      Result := True;
    end
    else begin
      iRvNo := 0;
      Result := False;
    end;
    close;
  end;
end;

procedure TfrmCow_F.btnSchClick(Sender: TObject);
var
  sDate, sLr_Gb : String;
begin
  if PnJiNo.Caption = '' then begin
    iMtNo := 0;
  end;

  if iMtNo < 0 then begin
    ShowMessage('ȣ ԷϽʽÿ!');
    exit;
  end;

  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  iMtNo := StrToInt(Trim(PnJiNo.Caption));

  if AucTagGetExMtNo(sOnCd, sDate, sAnCd, iMtNo) = true then begin
    sLr_Gb := LeftRightCheck(sOnCd, sDate, sAnCd, iMtNo);  // ¿챸 
    if sLr_Gb = '1' then begin     // 
      If Application.MessageBox('() ± ϵǾ ֽϴ. ()  ۾  Ͻðڽϱ?',
         '۾', MB_YESNO) <> IDYES then begin
         btnPum.Enabled   := False;
         btnSex.Enabled   := False;
         PnNo.Caption := '';
         PnJiNo.Caption := '';
         exit;
      end;
      sLrGb := '2';
      PnLr.Font.Color := clRed;
      PnLr.Caption := '';
    end
    else if sLr_Gb = '2' then begin     // 
      If Application.MessageBox('() ± ϵǾ ֽϴ. ()  ۾  Ͻðڽϱ?',
         '۾', MB_YESNO) <> IDYES then begin
         btnPum.Enabled   := False;
         btnSex.Enabled   := False;
         PnNo.Caption := '';
         PnJiNo.Caption := '';
         exit;
      end;
      sLrGb := '1';
      PnLr.Font.Color := clBlue;
      PnLr.Caption := '';
    end
    else if sLr_Gb = '3' then begin   //  
      If Application.MessageBox('± ()-() ϵǾ ֽϴ. ۾  Ͻðڽϱ?',
         '۾', MB_YESNO) <> IDYES then begin
         btnPum.Enabled   := False;
         btnSex.Enabled   := False;
         PnNo.Caption := '';
         PnJiNo.Caption := '';
         exit;
      end;
      sLrGb := '1';
      PnLr.Font.Color := clBlue;
      PnLr.Caption := '';
    end;
  end;

  if gf_PubQry('select receive_no, kind_cd, sex_cd from aucmeat ' +
               ' where online_cd = ''' + sOnCd  +   '''     '  +
               '   and kill_ymd  = ''' + sDate  +   '''     ' +
               '   and animal_cd = ''' + sAnCd  +   '''     ' +
               '   and io_gb    <> ''32''                  ' +
               '   and mt_no     = ''' + IntToStr(iMtNo) + ''' ') > 0 then begin
    PnNo.Caption  := gv_MyList.Strings[0];
    PnPum.Caption := getCommon('18', gv_MyList.Strings[1]);
    PnSex.Caption := getCommon('12', gv_MyList.Strings[2]);
    btnPum.Enabled   := False;
    btnSex.Enabled   := False;
    if sLr_Gb = '' then begin
      sLrGb := '1';
      PnLr.Font.Color := clBlue;
      PnLr.Caption := '';
    end;
  end
  else begin
    ShowMessage('ȣ : ' + IntToStr(iMtNo) +'  ʽϴ. ȮϽʽÿ!');
    PnJiNo.Caption := '';
  end;
end;

procedure TfrmCow_F.btnSavClick(Sender: TObject);
var
  sLTag_No, sRtag_No, sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);

  sLTag_No := Trim(edlTagNo.Text);
  sRTag_No := Trim(edRTagNo.Text);

  if ((Trim(PnNo.Caption) = '') or (StrToInt(PnNo.Caption) = 0)) then begin
    showmessage('ȣ ԷϽʽÿ!');
    exit;
  end;

  if ((Trim(PnJiNo.Caption) = '') or (StrToInt(PnJiNo.Caption) = 0)) then begin
    showmessage(' ȣ ԷϽʽÿ!');
    exit;
  end;

  if Trim(PnPum.Caption) = '' then begin
     ShowMessage('ǰ  ԷϽʽÿ!');
     exit;
  end;

  if Trim(PnSex.Caption) = '' then begin
     ShowMessage('  ԷϽʽÿ!');
     exit;
  end;

  if Trim(PnLr.Caption) = '' then begin
     ShowMessage(',  ԷϽʽÿ!');
     exit;
  end;

  if (Length(sLTag_No) = 11) then begin
    sTagNo := sLTag_no;
    sLrGb  := '1';
    edLTagno.Text := '';
  end
  else if (length(sRtag_no) = 11) then begin
    sTagNo := sRTag_no;
    sLrGb := '2';
    edRtagNo.Text := '';
  end
  else begin
    ShowMessage('Էµ ±׹ȣ ȮϽʽÿ!');
    exit;
  end;

  iRvNo := StrToInt(PnNo.Caption);
  iMtNo := StrToInt(PnJiNo.Caption);

  if gf_PubQry('select tag_no from auctag            '+
               ' where online_cd = '''+ sOnCd  + ''' '+
               '   and tag_no    = '''+ sTagNo + ''' '+
               '   and kill_ymd  = '''+ sDate  + ''' ') > 0 then begin
    If Application.MessageBox('± ڷᰡ ϵǾ ֽϴ. ۾  Ͻðڽϱ?',
                              '۾', MB_YESNO) <> IDYES then begin
       PnMsg3.Font.Color := clBlue;
       PnMsg3.Caption := '';
       exit;
    end;
  end;

  With Dm_Grd do begin // 
    Try
      DataBase.StartTransaction;

      DataExCheck;  //   ȣ ٸ ±׿ ɷ Ѿ ö   NULL Update
      InsertAucTag;
      InsertAucLogTag;
      DataBase.Commit;

      if sLrGb = '2' then begin
        if GetRvMtNo(sOnCd, sDate, sAnCd, iMtNo) = True then begin
          PnNo.Caption := IntToStr(iRvNo);
          PnJiNo.Caption := IntToStr(iMtNo);
          sLrGb := '1';
          PnLr.Font.Color := clBlue;
          PnLr.Caption := '';
          PnMsg3.Caption := '';
          PnMsg3.Font.Color := clBlue;
        end
        else begin
          PnMsg3.Font.Color := clRed;
          PnMsg3.Caption := '۾Ϸ';
          PnMsg4.Font.Color := clRed;
          PnMsg4.Caption := '۾Ϸ';
        end;
      end
      else if sLrGb = '1' then begin
         sLrGb := '2';
         PnLr.Font.Color := clRed;
         PnLr.Caption := '';
         PnMsg4.Caption := '´';
         PnMsg4.Font.Color := clBlue;
      end;

      iTotalCnt := GetTotalCnt;
      iWorkCnt  := GetInputCnt;
      PnMsg2.Caption := ' : ' + IntToStr(iTotalCnt - iWorkCnt);
      PnMsg1.Caption := ' : ' + IntToStr(iWorkCnt);

      except on E: EDbEngineError do begin   // ڷ  
        DataBase.Rollback;
        pnMsg1.Caption := ' : ' + IntToStr(iWorkCnt - 1);
        pnMsg2.Caption := ' : ' + IntToStr(iTotalCnt + 1);
        PnMsg3.Font.Color := clRed;
        PnMsg3.Caption := '';
        ShowMessage('ڷ Դϴ! Ȯϼ' + ' ' + E.Errors[0].Message);
        exit;
      end;
    end;
  end;
end;

procedure TfrmCow_F.DataExCheck;
var
  sRvNo, sMtNo, sDate : String;
begin
  sRvNo := Trim(PnNo.Caption);    // ȣ
  sMtNo := Trim(PnJiNo.Caption);  // ȣ
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select kill_ymd, receive_no, mt_no from auctag ' +
            ' where online_cd  = :oncd             ' +
            '   and kill_ymd   = :ymd              ' +
            '   and animal_cd  = :ancd             ' +
            '   and receive_no = :rvno             ' +
            '   and mt_no      = :mtno             ' +
            '   and lr_gb      = :lrgb             ');
    ParamByName('oncd').AsString := sOnCd;
    ParamByName('ymd' ).AsString := sDate;
    ParamByName('ancd').AsString := sAnCd;
    ParamByName('rvno').AsInteger := StrToint(sRvNo);
    ParamByName('mtno').AsInteger := StrToInt(sMtNo);
    ParamByName('lrgb').AsString := sLrGb;
    Open;
    if not eof then begin
      with QryTemp1 do begin
        Close;
        Sql.Clear;
        Sql.Add(' update auctag                       ' +
                '    set kill_ymd = null,             ' +
                '        receive_no = null,           ' +
                '        mt_no      = null            ' +
                '  where online_cd = :oncd            ' +
                '    and kill_ymd = :ymd              ' +
                '    and animal_cd  = :ancd           ' +
                '    and receive_no = :rvno           ' +
                '    and mt_no      = :mtno           ');
        ParamByName('oncd').AsString := sOnCd;
        ParamByName('ymd' ).AsString := sDate;
        ParamByName('ancd').AsString := sAnCd;
        ParamByName('rvno').AsInteger := StrToInt(sRvNo);
        ParamByName('mtno').AsInteger := StrToInt(sMtNo);
//        PrePare;
        ExecSql;
        close;
      end;
      close;
    end;
  end;
end;

procedure TfrmCow_F.InsertAucTag;
var
  sRvNo, sMtNo, sDate, sTag_No, sInputGb, sUpMtNo : String;
  dDate : TDateTime;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  sRvNo := Trim(PnNo.Caption);    // ȣ
  sMtNo := Trim(PnJiNo.Caption);  // ȣ
  sTag_No := Trim(sTagNo);   // ±׹ȣ
  dDate := udGetSysDate;
  sInputGb := 'I';  // T:± H:
  If sRvNo <> '' Then Begin
  if sMtNo <> '' then begin
     With QryTemp Do Begin
       Close;
       Sql.Clear;
       Sql.Add('select online_cd, tag_no, mt_no from auctag   ' +
               ' where online_cd  = :oncd                     ' +
               '   and tag_no     = :tag_no                   ');
       ParamByName('tag_no').AsString := sTag_No;
       ParamByName('oncd').AsInteger  := StrToInt(sOnCd);
       Open;
       If Not Eof Then begin
         sUpMtNo := IntToStr(FieldByName('mt_no').AsInteger);
         with QryTemp1 do begin
           Close;
           Sql.Clear;
           Sql.Add('update auctag                     ' +
                   '   set kill_ymd  = :ymd,          ' +
                   '       animal_cd = :ancd,         ' +
                   '       mt_no     = :mtno,         ' +
                   '       receive_no = :rvno,        ' +
                   '       lr_gb     = :lrgb,         ' +
                   '       weight    = 0    ,         ' +
                   '       trans_dt  = null ,         ' +
                   '       trans_gb  = ''0'',         ' +
                   '       oper_dt   = :operdt,       ' +
                   '       oper_nm   = :opernm,       ' +
                   '       input_gb  = :inpgb,        ' +
                   '       true_mt_no = :mtno,        ' +
                   '       err_text   = null          ' +
                   ' where online_cd = :oncd          ' +
                   '   and tag_no    = :tag_no        ');
           ParamByName('ymd').AsString    := sDate;
           ParamByName('ancd').AsString   := sAnCd;
           ParamByName('mtno').AsInteger  := StrToInt(sMtNo);
           ParamByName('rvno').AsInteger  := StrToInt(sRvNo);
           ParamByName('lrgb').AsString   := sLrGb;
           ParamByName('operdt').AsDateTime := dDate;
           ParamByName('opernm').AsString := gsUserName;
           ParamByName('inpgb').AsString  := sInputGb;
           ParamByName('tag_no').AsString := sTag_No;
           ParamByName('oncd').AsInteger  := StrToInt(sOnCd);
//           PrePare;
           ExecSql;
           close;
           sErr_Text := 'Update : ' + sUpMtNo;
         end;
       End
       Else Begin
         with QryTemp1 do begin
           Close;
           Sql.Clear;
           Sql.Add('Insert Into auctag                                           ' +
                   ' (online_cd, tag_no, kill_ymd, animal_cd, mt_no, receive_no, ' +
                   '  lr_gb, oper_dt, oper_nm, input_gb,                         ' +
                   '  weight, trans_dt, trans_gb, true_mt_no, err_text  )        ' +
                   'values (:oncd, :tag_no, :ymd, :anicd, :mtno, :rvno,          ' +
                   '  :lrgb, :opdt, :opnm, :iptgb,                               ' +
                   '  0, null, ''0'', :mtno, null   )                            ' );
           ParamByName('oncd').AsInteger  := StrToInt(sOnCd);
           ParamByName('tag_no').AsString := sTag_No;
           ParamByName('ymd').AsString    := sDate;
           ParamByName('anicd').AsString  := sAnCd;
           ParamByName('mtno').AsInteger  := StrToInt(sMtNo);
           ParamByName('rvno').AsInteger  := StrToInt(sRvNo);
           ParamByName('lrgb').AsString   := sLrGb;
           ParamByName('opdt').AsDateTime := dDate;
           ParamByName('opnm').AsString   := gsUserName;
           ParamByName('iptgb').AsString  := sInputGb;
//           prepare;
           ExecSql;
           close;
           sErr_Text := 'Insert : ' + sMtNo; 
         end;
       End;
       close;
     End;
  end
  else begin
     ShowMessage('ȣ ԷϽʽÿ!');
  end;    // if smtno <> '' end.
  End
  Else Begin
     ShowMessage('ȣ ԷϽʽÿ!');
  End;   // if srvno <> ''  end.
end;

procedure TfrmCow_F.InsertAucLogTag;
var
  sDate, sMtNo, sRvNo, sTag_No, sInputGb : String;
  dDate : TDateTime;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  sRvNo := Trim(PnNo.Caption);  // ȣ
  sMtNo := Trim(PnJiNo.Caption);  // ȣ
  sTag_No := Trim(sTagNO);
  dDate := udGetSysDate;
  sInputGb := 'I';  // T:± H:
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' insert into auclogtag                                            ' +
            ' (online_cd, tag_no, trans_dt, kill_ymd, mt_no, receive_no,       ' +
            '  animal_cd, lr_gb, oper_id, input_gb, log_gb, true_mt_no, err_text )' +
            ' values (:oncd, :tagno, :trsdt, :ymd, :mtno, :rvno,               ' +
            '         :ancd, :lrgb, :operid, :inpgb, :loggb, :mtno, :err_txt ) ' );
    ParamByName('oncd').AsInteger   := StrToInt(sOnCd);
    ParamByName('tagno').AsString   := sTag_No;
    ParamByName('trsdt').AsDateTime := dDate;
    ParamByName('ancd').AsString    := sAnCd;
    ParamByName('lrgb').AsString    := sLrGb;
    ParamByName('ymd').AsString     := sDate;
    ParamByName('mtno').AsInteger   := StrToInt(sMtNo);
    ParamByName('rvno').AsInteger   := StrToInt(sRvNo);
    ParamByName('operid').AsString  := gsUserId;
    ParamByName('inpgb').AsString   := sInputGb;
    ParamByName('loggb').AsString   := 'I';
    ParamByName('err_txt').AsString := sErr_Text;    
//    PrePare;
    ExecSql;
    close;
  end;
end;

//  ̺ ǰ ڵ忡  ڷ 
Function TfrmCow_F.getCommon(in_main_cd, in_sub_cd : String) : String;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add('select desc1 from auccommon                   ' +
            ' where main_cd = :main_cd                     ' +
            '   and sub_cd  = :sub_cd                      ');
    ParamByName('main_cd').AsString := in_main_cd;
    ParamByName('sub_cd').AsString := in_sub_cd;
    Open;
    if Not Eof then begin
       result := FieldByName('desc1').AsString;
    end
    else result := '';
    close;
  end;
end;

procedure TfrmCow_F.SerialInit;
begin
  TimeCnt := 0;
  TmConnect.Interval := iLampTime;
  TmConnect.Enabled := True;
  SendPacket(CMD_STATE, ID_CONTROLLER, [$00], 0);
end;

procedure TfrmCow_F.CmPtRxChar(Sender: TObject; Count: Integer);
var
  Cnt, i : Integer;
  TmpBuf : array[0..MAX_SIZE-1] of Byte;
begin
  Cnt := 0;
  FillChar(TmpBuf, MAX_SIZE, $00);
  Cnt := CmPt.Read(TmpBuf, Count);
  if(Cnt <= 0) then Exit;

  if TimeCnt <= 3 then begin
     Shape1.Pen.Color := clGreen;
     TmConnect.Enabled := False;
     TimeCnt := 0;
  end;

  for i:=0 to Cnt-1 do
  begin
    case TmpBuf[i] of
      _STX:
        begin
          pIdx:= 0;
          pBuf[pIdx] := _STX;
          Inc(pIdx);
        end;
      _ETX:
        begin
          pBuf[pIdx] := _ETX;
          Inc(pIdx);
        end;
      else
        begin
          pBuf[pIdx] := TmpBuf[i];
          inc(pIdx);

          if(pIdx >= MAX_SIZE) then
          begin
            pIdx := 0;
          end else if((pIdx > 2) and (pBuf[pIdx-2] = _ETX)) then
          begin
            NotificationHandler(pBuf, pIdx);
            pIdx := 0;
          end;
        end;
    end; // case..end
  end;
end;

function TfrmCow_F.SendPacket(cmd, id: byte; buf: array of byte;
            len: Integer) : integer;
var
  i,x: integer;
  bcc: byte;
  tx: array[0..250] of byte;
begin
  Result:= 0;
  if not CmPt.Connected then  Exit;

  x:= 0;
  tx[x]:= _STX;   Inc(x);
  tx[x]:= cmd;    Inc(x);
  tx[x]:= id;     Inc(x);

  move(buf, tx[x], len);
  Inc(x, len);

  tx[x]:= _ETX;   Inc(x);

  bcc:= 0;
  for i:=0 to x-1 do
    bcc:= bcc xor tx[i];
  bcc:= bcc or $80;

  if(bcc = $FF) then
    bcc:= $7F;

  tx[x]:= bcc;      Inc(x);
  // Send
  Result:= CmPt.Write(tx, x);

  if(Result > 0) then
  begin
//    showmessage(Format('SEND[%0.2d]: %s', [x, ArrayToString(tx,x)]));
  end else begin
//    showmessage('SEND FAIL...');
  end;
end;

procedure TfrmCow_F.NotificationHandler(buf: array of byte; cnt: Integer);
var
  i, ii, jj: integer;
  bcc: byte;
  AckNak: byte;
  p, p1: PChar;
  s : String;
begin
  s := '';
  ii := 0;
  bcc:= 0;
  for i:=0 to cnt-2 do
    bcc:= bcc xor buf[i];
  bcc:= bcc or $80;
  if(bcc = $FF) then bcc:= $7F;

  if(bcc = buf[cnt-1]) then
  begin
    AckNak:= _ACK;
  end else begin
    AckNak:= _NAK;
  end;

  case buf[1] of
    CMD_STATE: // Controller Init
      begin
        if cnt = 5 then begin// CMD
          Shape1.Pen.Color := clGreen;
          SendPacket(CMD_STATE, ID_CONTROLLER, [AckNak], 1);
        end;
      end;
    CMD_READER :
      begin
        p := PChar(@buf[0]);
        p := StrPos(p, ':');
        if(p = nil) then begin
          Exit;
        end;

        inc(p);
        p1 := StrPos(p, ':');
        if(p1 = nil) then begin
          Exit;
        end;

        if (p1 - p) <> 11 then begin
          Exit;
        end;

        Shape1.Pen.Color := clYellow;

        p[11] := #0;

        sTagNo := strpas(p);

        if ((Length(Trim(edlTagNo.Text)) = 11) and (Length(Trim(edRtagNo.Text)) = 11)) then begin
          exit;
        end;

        if not ((sLtag = sTagNo) or (sRtag = sTagNo)) then begin
        if sLrGb = '1' then begin
          if ((sLtag = sTagNo) or (sLtag = '')) then begin
            sLtag := sTagNo;
            PnMsg4.Font.Color := clRed;
            PnMsg4.Caption := '';
            PnLr.Font.Color := clBlue;
            sLrGb := '2';
            PnLr.Caption := '';
            edLTagNo.Text := sLtag;
          end;
        end
        else begin
          if ((sRtag = sTagNo) or (sRtag = '')) then begin
            sRtag := sTagNo;
            PnMsg3.Font.Color := clRed;
            PnMsg3.Caption := '';
            PnLr.Font.Color := clRed;
            sLrGb := '1';
            PnLr.Caption := '';
            edRTagNo.Text := sRtag;
          end;
        end;
        end;

        Shape1.Pen.Color := clBlue;
        SendPacket(CMD_LAMP, ID_LAMP, [LP_BLUE], 1);
        TimeCnt := 0;
        TmLamp.Interval := iLampTime;
        TmLamp.Enabled := True;

        SendPacket(CMD_READER, ID_READER, [AckNak], 1);
      end;
    CMD_LAMP:
      begin
        if cnt = 5 then begin// CMD
          SendPacket(CMD_LAMP, ID_LAMP, [AckNak], 1);
        end;
      end;
    CMD_LIMIT:
      begin
        SendPacket(CMD_LIMIT, ID_LIMIT, [AckNak], 1);

        if Length(sLtag) = 11 then begin
          sLrGb := '1';
          sLtag := '';
          btnSav.Click;
          Shape1.Pen.Color := clBlue;
          SendPacket(CMD_LAMP, ID_LAMP, [LP_BLUE], 1);
          TimeCnt := 0;
          TmLamp.Interval := iLampTime;
          TmLamp.Enabled := True;
        end
        else if Length(sRtag) = 11 then begin
          sLrGb := '2';
          sRtag := '';
          btnSav.Click;
          Shape1.Pen.Color := clBlue;
          SendPacket(CMD_LAMP, ID_LAMP, [LP_BLUE], 1);
          TimeCnt := 0;
          TmLamp.Interval := iLampTime;
          TmLamp.Enabled := True;
        end
        else begin
          Shape1.Pen.Color := clBlue;
          SendPacket(CMD_LAMP, ID_LAMP, [LP_RED], 1);
          TimeCnt := 0;
          TmLamp.Interval := iLampTime;
          TmLamp.Enabled := True;
        end;
{        else if length(sTagNo) = 11 then begin
          btnSav.Click;
          Shape1.Pen.Color := clBlue;
          SendPacket(CMD_LAMP, ID_LAMP, [LP_BLUE], 1);
          TimeCnt := 0;
          TmLamp.Interval := iLampTime;
          TmLamp.Enabled := True;
        end;                           }
        sTagNo := '';
        edlTagNo.Text := '';
        FillChar(pbuf, MAX_SIZE, $00);
        pidx := 0;
      end;
    CMD_ERROR:
      begin
        showmessage('Ʈѷ κҸ, ߻. Ʈѷ Ͻʽÿ!');
      end;
    else
      begin
        //
      end;
  end;
end;

function TfrmCow_F.ArrayToString(buf: array of byte; len: Integer): string;
var
  i: Integer;
begin
  result:= '';
  for I:=0 to (len-1) do
    result:= result + IntToHex(buf[i],2) + ' ';
end;

procedure TfrmCow_F.tmConnectTimer(Sender: TObject);
begin
  inc(TimeCnt);
  if TimeCnt > 3 then begin
     TmConnect.Enabled := False;
     TimeCnt := 0;
     shape1.Pen.Color := clWhite;
     showmessage('Ʈѷ ¸ ȮϽʽÿ!');
     exit;
  end;
end;

procedure TfrmCow_F.tmLampTimer(Sender: TObject);
begin
  inc(TimeCnt);
  if TimeCnt > 0 then begin
    SendPacket(CMD_LAMP, ID_LAMP, [LP_OFF], 1);
    TmLamp.Enabled := False;
    TimeCnt := 0;
    exit;
  end;
end;

procedure TfrmCow_F.btnPumClick(Sender: TObject);
begin
  if sKnd_cd = '11' then
    sKnd_Cd := '12'
  else if sKnd_Cd = '12' then
    sKnd_cd := '13'
  else if sKnd_Cd = '13' then
    sKnd_cd := '14'
  else if sKnd_Cd = '14' then
    sKnd_cd := '19'
  else if sKnd_Cd = '19' then
    sKnd_cd := '21'
  else if sKnd_Cd = '21' then
    sKnd_cd := '22'
  else if sKnd_Cd = '22' then
    sKnd_cd := '23'
  else if sKnd_Cd = '23' then
    sKnd_cd := '24'
  else if sKnd_Cd = '24' then
    sKnd_cd := '11';

  PnPum.Caption := getCommon('18',sKnd_cd);

end;

procedure TfrmCow_F.btnSexClick(Sender: TObject);
begin
  if sSex_cd = '1' then
    sSex_Cd := '2'
  else if sSex_cd = '2' then
    sSex_Cd := '3'
  else if sSex_cd = '3' then
    sSex_Cd := '4'
  else if sSex_cd = '4' then
    sSex_Cd := '1';

  PnSex.Caption := getCommon('12',sSex_cd);
end;

procedure TfrmCow_F.Image1Click(Sender: TObject);
begin
//  if Trim(PnNo.Caption) = '0000' then begin
  If PortChk = False then begin  // Ʈ    Setup ȭ Display
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
  end;
  SerialInit;
//  end;
end;

procedure TfrmCow_F.dtdateChange(Sender: TObject);
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);

  if GetMinMaxRvNo(sOnCd, sDate, sAnCd) then begin
    PnStNo.Caption := IntToStr(iMinRvNo);
    PnEdNo.Caption := IntToStr(iMaxRvNo);
  end
  else begin
    PnStNo.Caption := '0';
    PnEdNo.Caption := '0';
  end;

  iTotalCnt := GetTotalCnt;
  iWorkCnt  := GetInputCnt;
  PnMsg2.Caption := ' : ' + IntToStr(iTotalCnt - iWorkCnt);
  PnMsg1.Caption := ' : ' + IntToStr(iWorkCnt);
end;

procedure TfrmCow_F.Panel12Exit(Sender: TObject);
begin
  iClickCnt := 0;
end;

procedure TfrmCow_F.Panel12DblClick(Sender: TObject);
begin
  inc(iClickCnt);
  if iClickCnt = 10 then begin
    edlTagNo.Text := '';
    sTagNo := '';
    iClickCnt := 0;
    PnMsg3.Font.Color := clBlue;
    PnMsg3.Caption := '';
  end;
end;

end.
