unit Sel_F;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TfrmSel_F = class(TForm)
    Panel1: TPanel;
    PnPig: TPanel;
    PnCow: TPanel;
    Panel2: TPanel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure PnPigClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure PnCowClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSel_F: TfrmSel_F;

implementation

Uses DM_F, TchLib, Login_F, Pig_F, Cow_F;

{$R *.dfm}

procedure TfrmSel_F.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  gv_MyList.Free;
  Action := CaFree;
end;

procedure TfrmSel_F.FormCreate(Sender: TObject);
begin
  With TfrmLogin_F.Create(Application) Do
  Try
    Showmodal;
  Finally
    Free;
  End;
end;

procedure TfrmSel_F.PnPigClick(Sender: TObject);
begin
  With TfrmPig_F.Create(Application) Do
  Try
    Showmodal;
  Finally
    Free;
  End;
  Close;
end;

procedure TfrmSel_F.PnCowClick(Sender: TObject);
begin
  With TfrmCow_F.Create(Application) Do
  Try
    Showmodal;
  Finally
    Free;
  End;
  Close;

end;

procedure TfrmSel_F.FormActivate(Sender: TObject);
begin
  gv_MyList := TStringList.Create;
  if gbLogin=False Then
     Close;
end;

end.
