unit Cow_F;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, RXCtrls, ToolWin, StdCtrls, Buttons, ExtCtrls,ShellApi,
  RxGIF, CPDrv, IniFiles, CPort, DB, DBTables;

const
  CMD_STATE      = $61;  // 'a'  - ſ Ȯ
  CMD_LIMIT      = $62;  // 'b'  - Ʈ  
  CMD_READER     = $63;  // 'c'  - ˿
  CMD_LAMP       = $64;
  CMD_ERROR      = $65;

  ID_CONTROLLER  = $30;
  ID_READER      = $31;
  ID_LIMIT       = $32;
  ID_LAMP        = $33;

  LP_OFF         = $30;  // Lamp Off
  LP_RED         = $31;  // RED
  LP_BLUE        = $32;  // BLUE
  LP_ALL         = $33;  //   ON

  LIMIT_ON       = $31;  // '1'

  _STX           = $02;
  _ETX           = $03;
  _ACK           = $06;
  _NAK           = $15;

  MAX_SIZE       = 1024;

type
  TfrmCow_F = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    dtdate: TDateTimePicker;
    Image1: TImage;
    Image2: TImage;
    Panel7: TPanel;
    btn1: TButton;
    pnMsg1: TPanel;
    pnMsg2: TPanel;
    PnMsg3: TPanel;
    btn2: TButton;
    btn3: TButton;
    btn4: TButton;
    btn5: TButton;
    btn6: TButton;
    btn7: TButton;
    btn8: TButton;
    btn9: TButton;
    btn0: TButton;
    pnNo: TPanel;
    pnJiNo: TPanel;
    CmPt: TComPort;
    QryTemp: TQuery;
    QryTemp1: TQuery;
    tmConnect: TTimer;
    Panel11: TPanel;
    pnstno: TPanel;
    Panel13: TPanel;
    pnedno: TPanel;
    Panel12: TPanel;
    edTagNo: TEdit;
    Panel8: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    btnSav: TButton;
    btnSch: TButton;
    btnIpt: TButton;
    btnClr: TButton;
    btnExt: TButton;
    Panel16: TPanel;
    Panel17: TPanel;
    PnPum: TPanel;
    btnPum: TButton;
    PnSex: TPanel;
    Panel20: TPanel;
    PnLr: TPanel;
    btnSex: TButton;
    btnLr: TButton;
    tmLamp: TTimer;
    pnJiStNo: TPanel;
    Panel19: TPanel;
    pnjiedno: TPanel;
    Panel18: TPanel;
    procedure btnExtClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ClearScreen;
    procedure FormCreate(Sender: TObject);
    procedure btn1Click(Sender: TObject);
    procedure pnNoClick(Sender: TObject);
    procedure pnJiNoClick(Sender: TObject);
    procedure btnClrClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image2Click(Sender: TObject);
    procedure btnSchClick(Sender: TObject);
    procedure btnSavClick(Sender: TObject);
    procedure InsertAucTag;
    procedure InsertAucLogTag;

    function  PortChk : Boolean;
    function  GetTotalCnt : Integer;
    function  GetInputCnt : Integer;
    function  GetMinMaxRvNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String) :boolean;
    function  GetMinMaxMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                            in_iRvNo:Integer) :boolean;
    function  AucTagGetRvNo(in_sOnCd, in_Kill_Ymd, In_sAnCd : String;
                      In_IRvNo : Integer) : Boolean;
    function  AucTagGetMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                      In_iRvNo,in_IMtNo: Integer) : Boolean;
    function  AucMeatGetRvNo(in_sOnCd, in_Kill_Ymd, In_sAnCd : String;
                      In_IRvNo : Integer) : Boolean;
    function  AucMeatGetMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                      In_iRvNo,in_IMtNo: Integer) : Boolean;
    function  AucTagGetExRvNo(in_sOnCd, in_Kill_Ymd, In_sAnCd : String;
                      In_IRvNo : Integer) : Boolean;
    function  AucTagGetExMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                      In_iRvNo,in_IMtNo: Integer) : Boolean;
    function  LeftRightCheck(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                      In_iRvNo,in_IMtNo: Integer) : Boolean;
    function  GetNumberChk : boolean;

    function  getCommon(in_main_cd, in_sub_cd : String) : String;
    procedure dtdateExit(Sender: TObject);
    procedure btnLrClick(Sender: TObject);

    procedure DataExCheck;
    procedure SerialInit;
    procedure CmPtRxChar(Sender: TObject; Count: Integer);
    procedure tmConnectTimer(Sender: TObject);
    procedure tmLampTimer(Sender: TObject);
    procedure btnPumClick(Sender: TObject);
    procedure btnSexClick(Sender: TObject);
    
  private
    { Private declarations }
    pBuf: array[0..MAX_SIZE-1] of Byte;
    pIdx: Integer;
    TimeCnt : DWord;

  public
    { Public declarations }
    procedure NotificationHandler(buf: array of byte; cnt: Integer);
    function SendPacket(cmd: byte; id: byte; buf:array of byte; len: Integer): Integer;

    function ArrayToString(buf:array of byte; len:Integer): string;


  end;

var
  frmCow_F: TfrmCow_F;

implementation

uses DM_F, Setup, TchLib;

Var IptFlag, InsertFlag : Boolean;
  sPort, sRate, sOnCd, sTagNo : String;
  pbDate, sAnCd, sLrGb, sKnd_cd, sSex_Cd : String;
  iMtNo, iWorkCnt, iTotalCnt : integer;
  iMinRvNo, iMaxRvNo, iMinMtNo, iMaxMtNo,iRvNo : Integer;

{$R *.dfm}

procedure TfrmCow_F.btnExtClick(Sender: TObject);
begin
  If Application.MessageBox('Ͻðڽϱ?', '',MB_YESNO) = IDYES then begin
     CmPt.Close;
     Close;
  end;
end;

procedure TfrmCow_F.FormKeyPress(Sender: TObject; var Key: Char);
begin
   If (Key = #13) Then
   Begin
      Key := #0;
      PerForm(WM_NEXTDLGCTL, 0, 0);
   End;
end;

procedure TfrmCow_F.ClearScreen;
begin
  IptFlag          := True;
  PnNo.Caption     := '';
  PnNo.Color       := ClWhite;
  PnJiNo.Color     := $00FDFDEA;
  PnJiNo.Caption   := '';
  PnMsg3.Font.Color := clBlue;
  PnMsg3.Caption   := '';
  sKnd_cd          := '11';
  PnPum.Caption    := '';
  sSex_Cd          := '1';
  PnSex.Caption    := '';
  sLrGb            := '1';
  PnLr.Caption     := '';
  PnLr.Font.Color  := clGreen;
  btnPum.Enabled   := True;
  btnSex.Enabled   := True;
end;

procedure TfrmCow_F.FormCreate(Sender: TObject);
begin
  iMtNo     := 0;   //  ʱȭ
  iTotalCnt := 0;   // ü ۾ 
  iWorkCnt  := 0;   //  ۾  
  iMinRvNo  := 0; iMaxRvNo := 0; iMinMtNo  := 0; iMaxMtNo := 0;
  edTagNo.Text := '';
  sAnCd     := '1';
  InsertFlag := True;
  TmConnect.Enabled := false;
  TmLamp.Enabled := false;

  ClearScreen;
  btnPum.Enabled   := False;
  btnSex.Enabled   := False;

  DateTimeToString(pbDate, 'YYYY-MM-DD', gdDate);

  DtDate.Date      := StrToDateTime(pbDate);

 //  αν Ʈ üũ
  If PortChk = False then begin  // Ʈ    Setup ȭ Display
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
  end;

  if AucTagGetRvNo(sOnCd, pbDate, sAnCd, iRvNo) = true then begin // tag̺ ȣ  ϸ
    if AucTagGetMtNo(sOnCd, pbDate, sAnCd, iRvNo, iMtNo) = true then begin // tag ̺ ȣ  ϸ
      if AucMeatGetMtNo(sOnCd, pbDate, sAnCd, iRvNo, iMtNo+1) = true then begin  //ȣ +1 ؼ  ϸ ȭ鿡 Display
        PnNo.Caption   := IntToStr(iRvNo);
        PnJiNo.Caption := IntToStr(iMtNo);
      end
      else begin // +1  ȣ  
        if AucMeatGetRvNo(sOnCd, pbDate, sAnCd, iRvNo+1) = true then begin // ̺ +1  ȣ   üũ
          if AucMeatGetMtNo(sOnCd, pbDate, sAnCd, iRvNo, iMtNo) = true then begin
            PnNo.Caption := IntToStr(iRvNo);
            PnJiNo.Caption := IntToStr(iMtNo);
          end;
        end
        else begin
          showmessage('ڷḦ ȮϽʽÿ!');
        end;
      end;
    end
    else begin
      PnNo.Caption := IntToStr(iRvNo);
      PnJiNo.Caption := '0';
      ShowMessage('± ȣ : ' + IntToStr(iRvNo) + ' ȣ  ʽϴ!');
    end;
  end
  else begin  // ± ̺ ڷᰡ  
    if AucMeatGetRvNo(sOnCd, pbDate, sAnCd, iRvNo) = true then begin // ̺ ڷ ȣ
      if AucMeatGetMtNo(sOnCd, pbDate, sAnCd, iRvNo, iMtNo) = true then begin
        PnNo.Caption   := IntToStr(iRvNo);
        PnJiNo.Caption := IntToStr(iMtNo);
      end
      else begin
        PnNo.Caption := IntToStr(iRvNo);
        PnJiNo.Caption := '0';
        showmessage('ȣ : ' + IntToStr(iRvNo) + ' Ϲȣ ϴ');
      end;
    end
    else showmessage('ڷḦ ȮϽʽÿ!');
  end;

  if GetMinMaxRvNo(sOnCd, pbDate, sAnCd) = true then begin
    PnStNo.Caption := IntToStr(iMinRvNo);
    PnEdNo.Caption := IntToStr(iMaxRvNo);
  end
  else begin
    PnStNo.Caption := '0';
    PnEdNo.Caption := '0';
  end;

  if GetMinMaxMtNo(sOnCd, pbDate, sAncd, iRvNo) = true then begin
    PnJiStNo.Caption := IntToStr(iMinMtNo);
    PnJiEdNo.Caption := IntToStr(iMaxMtNo);
  end
  else begin
    PnJiStNo.Caption := '0';
    PnJiEdNo.Caption := '0';
  end;

  SerialInit;

  iTotalCnt := GetTotalCnt;
  iWorkCnt  := GetInputCnt;
  PnMsg2.Caption := ' : ' + IntToStr(iTotalCnt - iWorkCnt);
  PnMsg1.Caption := ' : ' + IntToStr(iWorkCnt);
end;

Function TfrmCow_F.PortChk : Boolean;
Var MyIni : TIniFile;
    sSysPath : String;
Begin
  CmPt.Open;
  if Not CmPt.Connected then
     result := false
  else
     result := true;

  sSysPath := GetCurrentDir + '\Setup.ini';
  MyIni := TIniFile.Create(sSysPath);
  If FileExists(sSysPath) = False Then Begin
     Result := false;
     Exit;
  end
  else begin
    sPort := MyIni.ReadString('ȯ漳', 'Port', '');
    sRate := MyIni.ReadString('ȯ漳', 'Speed', '');
    sOnCd  := MyIni.ReadString('ȯ漳', 'OnLineCode', '');
  // Ʈѷ Ʈ  üũ
    Case StrToInt(sPort) Of     // Ʈѷ Ʈȣ
      0 : begin
            CmPt.Port := 'COM1';
          end;
      1 : begin
            CmPt.Port := 'COM2';
          end;
      2 : begin
            CmPt.Port := 'COM3';
          end;
      4 : begin
            CmPt.Port := 'COM4';
          end;
    End;

    Case StrToInt(sRate) Of   // ѷ Ʈӵ
       0 : begin
             CmPt.BaudRate      := br2400;
           end;
       1 : begin
             CmPt.BaudRate      := br4800;
           end;
       2 : begin
             CmPt.BaudRate      := br9600;
           end;
       3 : begin
             CmPt.BaudRate      := br14400;
           end;
       4 : begin
             CmPt.BaudRate      := br19200;
           end;
       5 : begin
             CmPt.BaudRate      := br38400;
           end;
       6 : begin
             CmPt.BaudRate      := br56000;
           end;
    End;
  end;
End;

procedure TfrmCow_F.btn1Click(Sender: TObject);
begin
  if IptFlag = True Then Begin
    PnJiNO.Caption := PnJiNo.Caption + (Sender As TButton).Caption;
    if Length(PnJiNo.Caption) > 4 then begin
          ShowMessage('ϵ ȣ ʰ!');
          PnJiNo.Caption := Copy(PnJiNo.Caption, 0, 4);
    end;
  End
  Else Begin
    PnNo.Caption := PnNo.Caption + (Sender As TButton).Caption;
    If Length(PnNo.Caption) > 4 Then begin
       ShowMessage('ϵ ȣʰ!');
       PnNo.Caption := copy(PnNo.Caption, 0, 4);
    end;
  end;
end;

procedure TfrmCow_F.pnNoClick(Sender: TObject);
begin
  IptFlag := False;
  PnNo.Caption := '';
  PnNo.Color := $00FDFDEA;
  PnJiNo.Color := ClWhite;
end;

procedure TfrmCow_F.pnJiNoClick(Sender: TObject);
begin
  IptFlag := True;
  PnJiNo.Caption := '';
  PnNo.Color := ClWhite;
  PnJiNo.Color := $00FDFDEA;
end;

procedure TfrmCow_F.btnClrClick(Sender: TObject);
begin
  ClearScreen;
end;

procedure TfrmCow_F.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   If (Shift = [ssShift, ssAlt]) and (Key = VK_F1) Then
   Begin
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
   End;

   If PortChk = False then begin  // Ʈ    Setup ȭ Display
      frmSetup := TfrmSetup.Create(Application);
      frmSetup.ShowModal;
   end;
end;

procedure TfrmCow_F.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CmPt.Close;
  Action := CaFree;
end;

procedure TfrmCow_F.btnLrClick(Sender: TObject);
begin
  if sLrGb = '1' then begin
     sLrGb := '2';
     PnLr.Caption := '';
     PnLr.Font.Color := clRed;
  end
  else begin
     sLrGb := '1';
     PnLr.Caption := '';
     PnLr.Font.Color := clGreen;
  end;
end;

procedure TfrmCow_F.Image2Click(Sender: TObject);
begin
  If PnNo.Caption = '0000' then begin
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
  end;

  If PortChk = False then begin  // Ʈ    Setup ȭ Display
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
  end;
end;

Function TfrmCow_F.GetTotalCnt : Integer;
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select count(mt_no) cnt from aucmeat      ' +
            '  where online_cd = :oncd                  ' +
            '    and kill_ymd  = :ymd                   ' +
            '    and animal_cd = :ancd                  ');
    ParamByName('oncd').AsInteger := StrToInt(sOnCd);
    ParamByName('ymd').AsString   := sDate;
    ParamByName('ancd').AsString  := sAnCd;
    Open;
    if Not Eof then
       Result := FieldByName('cnt').AsInteger
    else Result := 0;
  end;
end;

Function TfrmCow_F.GetInPutCnt : Integer;
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select count(mt_no) cnt from auctag       ' +
            '  where online_cd = :oncd                  ' +
            '    and kill_ymd  = :ymd                   ' +
            '    and animal_cd = :ancd                  ');
    ParamByName('oncd').AsInteger := StrToInt(sOnCd);
    ParamByName('ymd').AsString   := sDate;
    ParamByName('ancd').AsString  := sAnCd;
    Open;
    if Not Eof then
       Result := FieldByName('cnt').AsInteger
    else Result := 0;
  end;
end;

function TfrmCow_F.GetMinMaxRvNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String) : boolean;
begin
  With QryTemp Do Begin
    Close;
    Sql.Clear;
    Sql.Add(' select min(receive_no) min_rv_no,           ' +
            '        max(receive_no) max_rv_no            ' +
            '   from aucmeat                              ' +
            '  where online_cd = :oncd                    ' +
            '    and kill_ymd  = :ymd                     ' +
            '    and animal_cd = :sAnCd                   ' );
    ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd').AsString   := in_Kill_Ymd;
    ParamByName('sAnCd').AsString := In_sAnCd;
    Open;
    if Not eof then begin
      iMinRvNo := FieldByName('min_rv_no').AsInteger;
      iMaxRvNo := FieldByName('max_rv_no').AsInteger;
      Result := True;
    end
    else begin
      iMinRvNo := 0;
      iMaxRvNo := 0;
      Result := False;
    end;
  end;
end;

function TfrmCow_F.GetMinMaxMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                                 in_iRvNo : Integer) : Boolean;
begin
  If in_iRvNo >= 0 then begin
     With QryTemp Do Begin
       Close;
       Sql.Clear;
       Sql.Add(' select min(mt_no) min_mt_no,                ' +
               '        max(mt_no) max_mt_no                 ' +
               '   from aucmeat                              ' +
               '  where online_cd = :oncd                    ' +
               '    and kill_ymd  = :ymd                     ' +
               '    and animal_cd = :sAnCd                   ' +
               '    and receive_no = :rcvno                  ' +
               '  group by receive_no                        ' );
       ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
       ParamByName('ymd').AsString   := in_Kill_Ymd;
       ParamByName('sAnCd').AsString   := in_sAnCd;
       ParamByName('rcvno').AsInteger := in_iRvNo;
       Open;
       if Not eof then begin
         iMinMtNo := FieldByName('min_mt_no').AsInteger;
         iMaxMtNo := FieldByName('max_mt_no').AsInteger;
         Result := true;
       end
       else begin
         iMinMtNo := 0;
         iMaxMtNo := 0;
         Result := false;
       end;
     end;
  end
  else begin
    ShowMessage('ȣ ԷϽʽÿ!');
  end;
end;

function TfrmCow_F.AucTagGetRvNo(in_sOnCd, in_Kill_Ymd, In_sAnCd : String;
                           in_IRvNo : Integer) : Boolean;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select max(receive_no) max_rv_no   ' +
            '   from auctag                      ' +
            '  where online_cd = :sOnCd          ' +
            '    and kill_ymd  = :ymd            ' +
            '    and animal_cd = :ancd           ' +
            '    and receive_no >= :rvno         ');
    ParamByName('sOnCd').AsInteger  := StrToInt(in_sOnCd);
    ParamByName('ymd'  ).AsString  := in_Kill_Ymd;
    ParamByName('ancd' ).AsString  := in_sAnCd;
    ParamByName('rvno' ).AsInteger := in_IRvNo;
    Open;
    if FieldByName('max_rv_no').AsInteger > 0 then begin
      iRvNo := FieldByName('max_rv_no').AsInteger;
      Result := true;
    end
    else begin
      iRvNo := in_iRvNo - 1;
      Result := false;
    end;    // if  end
  end;      // with qrytemp end
end;

// ̺  ȣ    
function TfrmCow_F.AucMeatGetRvNo(in_sOnCd, in_Kill_Ymd, In_sAnCd : String;
                           in_IRvNo : Integer) : Boolean;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select min(receive_no) min_rv_no   ' +
            '   from aucMeat                     ' +
            '  where online_cd = :sOnCd          ' +
            '    and kill_ymd  = :ymd            ' +
            '    and animal_cd = :ancd           ' +
            '    and receive_no >= :rvno         ');
    ParamByName('sOnCd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd'  ).AsString  := in_Kill_Ymd;
    ParamByName('ancd' ).AsString  := in_sAnCd;
    ParamByName('rvno' ).AsInteger := in_IRvNo;
    Open;
    if FieldByName('min_rv_no').AsInteger > 0 then begin
      iRvNo := FieldByName('min_rv_no').AsInteger;
      Result := true;
    end
    else begin
      iRvNo := in_iRvNo;
      Result := false;
    end;    // if  end
  end;      // with qrytemp end
end;

// ± ̺ ȣ  ū  
function TfrmCow_F.AucTagGetMtNo(in_sOnCd, in_Kill_Ymd, In_sAnCd : String;
                           in_IRvNo, in_IMtNo : Integer) : Boolean;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select max(mt_no) max_mt_no        ' +
            '   from auctag                      ' +
            '  where online_cd = :sOnCd          ' +
            '    and kill_ymd  = :ymd            ' +
            '    and animal_cd = :ancd           ' +
            '    and receive_no = :rvno          ' +
            '    and mt_no     >= :mtno          ' );
    ParamByName('sOnCd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd'  ).AsString  := in_Kill_Ymd;
    ParamByName('ancd' ).AsString  := in_sAnCd;
    ParamByName('mtno' ).AsInteger := in_IMtNo;
    ParamByName('rvno' ).AsInteger := in_IRvNo;
    Open;
    if FieldByName('max_mt_no').AsInteger > 0 then begin
      iMtNo := FieldByName('max_mt_no').AsInteger;
      Result := True;
    end
    else begin
      iMtNo := in_iMtNo-1;
      Result := False;
    end;     // if  end
  end;       // with qrytemp end
end;

function TfrmCow_F.LeftRightCheck(in_sOnCd, in_kill_ymd, in_sAnCd : String;
                                  in_iRvNo, in_iMtNo : integer) : boolean;
begin
  with QryTemp do begin   // ¿  
    Close;
    Sql.Clear;
    Sql.Add(' select (select lr_gb from auctag a              ' +
            '        where online_cd = :oncd                  ' +
            '          and kill_ymd  = :ymd                   ' +
            '          and animal_cd = :ancd                  ' +
            '          and  mt_no    = :mtno                  ' +
            '          and lr_gb     = ''1''                  ' +
            '          and receive_no = :rvno) lrgb1,         ' +
            '      (select lr_gb from auctag b                ' +
            '        where online_cd = :oncd                  ' +
            '          and kill_ymd  = :ymd                   ' +
            '          and animal_cd = :oncd                  ' +
            '          and  mt_no     = :mtno                 ' +
            '          and lr_gb      = ''2''                 ' +
            '          and receive_no = :rvno ) lrgb2         ' +
            '         from auctag c                           ' +
            '        where online_cd = :oncd                  ' +
            '          and kill_ymd  = :ymd                   ' +
            '          and animal_cd = :ancd                  ' +
            '          and  mt_no     = :mtno                 ' +
            '          and receive_no = :rvno                 ' +
            '         group by mt_no, animal_cd, receive_no   ');
    ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd' ).AsString  := in_Kill_Ymd;
    ParamByName('ancd').AsString  := in_sAnCd;
    ParamByName('mtno').AsInteger := iMtNo;
    ParamByName('rvno').AsInteger := in_IRvNo;
    Open;
    if ((FieldByName('lrgb1').AsString = '1') and
       (FieldByName('lrgb2').AsString <> '2')) then begin
       sLrGb := FieldByName('lrgb1').AsString;
       PnLr.Caption := '';
       Result := true;
   end
    else if ((FieldByName('lrgb1').AsString <> '1') and
             (FieldByName('lrgb2').AsString = '2')) then begin
       sLrGb := FieldByName('lrgb2').AsString;
       PnLr.Caption := '';
       result := true;
    end
    else if ((FieldByName('lrgb1').AsString = '1') and
             (FieldByName('lrgb2').AsString = '2')) then begin
      Result := false;
    end
    else begin
       ShowMessage('ȣ : '+IntToStr(iMtNo)+' ڷ!');
       result := false;
    end;
  end;
end;

//  ̺ ȣ    
function TfrmCow_F.AucMeatGetMtNo(in_sOnCd, in_Kill_Ymd, In_sAnCd : String;
                           in_IRvNo, in_IMtNo : Integer) : Boolean;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select min(mt_no) min_mt_no        ' +
            '   from aucMeat                     ' +
            '  where online_cd = :sOnCd          ' +
            '    and kill_ymd  = :ymd            ' +
            '    and animal_cd = :ancd           ' +
            '    and receive_no = :rvno          ' +
            '    and mt_no      >= :mtno         ');
    ParamByName('sOnCd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd'  ).AsString  := in_Kill_Ymd;
    ParamByName('ancd' ).AsString  := in_sAnCd;
    ParamByName('mtno' ).AsInteger := in_IMtNo;
    ParamByName('rvno' ).AsInteger := in_IRvNo;
    Open;
    if FieldByName('min_mt_no').AsInteger > 0 then begin
      iMtNo := FieldByName('min_mt_no').AsInteger; // ȣ
      Result := true;
      with QryTemp1 do begin
        Close;
        Sql.Clear;
        Sql.Add(' select kind_cd, sex_cd  from aucmeat        ' +
                '  where online_cd = :oncd                    ' +
                '    and kill_ymd  = :ymd                     ' +
                '    and animal_cd = :ancd                    ' +
                '    and mt_no     = :mtno                    ' +
                '    and receive_no = :rcvno                  ');
        ParamByName('oncd').AsInteger := StrToInt(sOnCd);
        ParamByName('ymd').AsString   := in_kill_ymd;
        ParamByName('ancd').AsString  := in_sAnCd;
        ParamByName('rcvno').AsInteger := in_iRvNo;
        ParamByName('mtno').AsInteger  := iMtNo;
        Open;
        if Not Eof then begin
           sKnd_Cd := FieldByName('kind_cd').AsString;
           sSex_Cd := FieldByName('sex_cd' ).AsString;
           PnPum.Caption := getCommon('18', sKnd_Cd);
           PnSex.Caption := getCommon('12', sSex_Cd);
           sLrGb := '1';
           PnLr.Caption := '';
           PnLr.Font.Color := clGreen;
        end;
     end;
     result := true;
    end
    else begin
      iMtNo := in_iMtNo;
      Result := False;
    end;     // if  end
  end;       // with qrytemp end
end;

// ȣ ǳʶٰ   ٽ ó   ϵ ڷ Check ϱ
function TfrmCow_F.AucTagGetExRvNo(in_sOnCd, in_Kill_Ymd, In_sAnCd : String;
                           in_IRvNo : Integer) : Boolean;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select receive_no                  ' +
            '   from auctag                      ' +
            '  where online_cd = :sOnCd          ' +
            '    and kill_ymd  = :ymd            ' +
            '    and animal_cd = :ancd           ' +
            '    and receive_no = :rvno          ');
    ParamByName('sOnCd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd'  ).AsString  := in_Kill_Ymd;
    ParamByName('ancd' ).AsString  := in_sAnCd;
    ParamByName('rvno' ).AsInteger := in_IRvNo;
    Open;
    if not eof then begin
      iRvNo  := in_iRvNo;
      Result := true;
    end
    else begin
      iRvNo  := iRvNo;
      Result := false;
    end;    // if  end
  end;      // with qrytemp end
end;

// ȣ ǳʶٰ   ٽ ó   ϵ ڷ Check ϱ
function TfrmCow_F.AucTagGetExMtNo(in_sOnCd, in_Kill_Ymd, In_sAnCd : String;
                           in_IRvNo, in_IMtNo : Integer) : Boolean;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select mt_no                       ' +
            '   from auctag                      ' +
            '  where online_cd = :sOnCd          ' +
            '    and kill_ymd  = :ymd            ' +
            '    and animal_cd = :ancd           ' +
            '    and receive_no = :rvno          ' +
            '    and mt_no      = :mtno          ' );
    ParamByName('sOnCd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd'  ).AsString  := in_Kill_Ymd;
    ParamByName('ancd' ).AsString  := in_sAnCd;
    ParamByName('mtno' ).AsInteger := in_IMtNo;
    ParamByName('rvno' ).AsInteger := in_IRvNo;
    Open;
    if not eof then begin
      iMtNo  := in_iMtNo;
      Result := true;
    end
    else begin
      iMtNo := iMtNo;
      Result := False;
    end;     // if  end
  end;       // with qrytemp end
end;

procedure TfrmCow_F.btnSchClick(Sender: TObject);
var
  sDate : String;
begin
  if PnJiNo.Caption = '' then begin
    ShowMessage('ȣ ԷϽʽÿ!');
    exit;
  end;

  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  iMtNo := StrToInt(Trim(PnJiNo.Caption));

  if gf_PubQry(' select mt_no from auctag               '+
               '  where online_cd = ''' + sOnCd +   ''' '+
               '    and kill_ymd  = ''' + sDate +   ''' '+
               '    and animal_cd = ''' + sAnCd +   ''' '+
               '    and mt_no     = ''' + IntToStr(iMtNo) + '''') > 0 then begin
    If Application.MessageBox('± ϵǾ ֽϴ. ۾  Ͻðڽϱ?',
       '۾', MB_YESNO) <> IDYES then begin
       btnPum.Enabled   := False;
       btnSex.Enabled   := False;
       PnNo.Caption := '';
       PnJiNo.Caption := '';
       exit;
    end;
//    if LeftRightCheck(sOnCd, sDate, sAnCd, iRvNo, iMtNo) = true then begin  // , Ͽ ʿ 
  end;

  if gf_PubQry('select receive_no, kind_cd, sex_cd from aucmeat ' +
               ' where online_cd = ''' + sOnCd  +   '''     '  +
               '   and kill_ymd  = ''' + sDate  +   '''     ' +
               '   and animal_cd = ''' + sAnCd  +   '''     ' +
               '   and mt_no     = ''' + IntToStr(iMtNo) + ''' ') > 0 then begin
    PnNo.Caption  := gv_MyList.Strings[0];
    PnPum.Caption := getCommon('18', gv_MyList.Strings[1]);
    PnSex.Caption := getCommon('12', gv_MyList.Strings[2]);
    btnPum.Enabled   := False;
    btnSex.Enabled   := False;
  end
  else begin
    ShowMessage('ȣ : ' + IntToStr(iMtNo) +'  ʽϴ. ȮϽʽÿ!');
    PnJiNo.Caption := '';
  end;
end;

procedure TfrmCow_F.btnSavClick(Sender: TObject);
var
  sTagNo, sDate : String;
  iTemp : Integer;
begin
  iRvNo := StrToInt(PnNo.Caption);
  iMtNo := StrToInt(PnJiNo.Caption);

  iTemp := iRvNo;
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  sTagNo := Trim(edTagNo.Text);

  if Trim(PnNo.Caption) = '' then begin
    showmessage('ȣ ԷϽʽÿ!');
    exit;
  end;

  if Trim(PnJiNo.Caption) = '' then begin
    showmessage(' ȣ ԷϽʽÿ!');
    exit;
  end;

  if Trim(PnPum.Caption) = '' then begin
     ShowMessage('ǰ  ԷϽʽÿ!');
     exit;
  end;

  if Trim(PnSex.Caption) = '' then begin
     ShowMessage('  ԷϽʽÿ!');
     exit;
  end;

  if Trim(PnLr.Caption) = '' then begin
     ShowMessage(',  ԷϽʽÿ!');
     exit;
  end;

  if sTagNo = '' then begin
    ShowMessage('Էµ ±׹ȣ ϴ. ȮϽʽÿ!');
    exit;
  end;

  if gf_PubQry('select tag_no from auctag            '+
               ' where online_cd = '''+ sOnCd  + ''' '+
               '   and tag_no    = '''+ sTagNo + ''' '+
               '   and kill_ymd  = '''+ sDate  + ''' '+
               '   and animal_cd = '''+ sAnCd  + ''' ') > 0 then begin
    If Application.MessageBox('± ڷᰡ ϵǾ ֽϴ. ۾  Ͻðڽϱ?',
                              '۾', MB_YESNO) <> IDYES then begin
       exit;
    end;
  end;

  With Dm_Grd do begin // 
    Try
      DataBase.StartTransaction;
      PnMsg3.Caption := '';
      PnMsg3.Font.Color := clGreen;

      DataExCheck;
      InsertAucTag;
      InsertAucLogTag;
      DataBase.Commit;

      if sLrGb = '2' then begin
        if GetNumberChk = true then begin
          inc(iWorkCnt);
          iTotalCnt := iTotalCnt - 1;
          pnMsg1.Caption := ' : ' + IntToStr(iWorkCnt);
          pnMsg2.Caption := ' : ' + IntToStr(iTotalCnt);
        end;

        if iTemp <> iRvNo then begin
          if GetMinMaxMtNo(sOnCd, pbDate, sAncd, iRvNo) = true then begin
            PnJiStNo.Caption := IntToStr(iMinMtNo);
            PnJiEdNo.Caption := IntToStr(iMaxMtNo);
          end
          else begin
            PnJiStNo.Caption := '0';
            PnJiEdNo.Caption := '0';
          end;
        end;
        sLrGb := '1';
        PnLr.Font.Color := clBlue;
        PnLr.Caption := '';
      end
      else begin
        sLrGb := '2';
        PnLr.Font.Color := clRed;
        PnLr.Caption := '';
      end;
      PnMsg3.Font.Color := clBlue;
      PnMsg3.Caption := '';

      except on E: EDbEngineError do begin   // ڷ  
        DataBase.Rollback;
        pnMsg1.Caption := ' : ' + IntToStr(iWorkCnt - 1);
        pnMsg2.Caption := ' : ' + IntToStr(iTotalCnt + 1);
        PnMsg3.Font.Color := clRed;
        PnMsg3.Caption := '';
        ShowMessage('ڷ Դϴ! Ȯϼ' + ' ' + E.Errors[0].Message);
        exit;
      end;
    end;
  end;
end;

function TfrmCow_F.GetNumberChk : boolean;
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  if iMtNo = 0 then
    exit;
  if iMtNo = iMaxMtNo then begin  //  ȣ ȣ  ū 
    if AucTagGetExRvNo(sOnCd, sDate, sAnCd, iRvNo+1) = true then begin  // ȣ +1  ± ̺  
      if AucTagGetRvNo(sOnCd, sDate, sAnCd, iRvNo) = true then begin    // ±̺ ȣ  ū 
         if AucTagGetMtNo(sOnCd, sDate, sAnCd, iRvNo, iMtNo) = true then begin  // ±̺ ȣ  ū 
           if AucMeatGetMtNo(sOnCd, sDate, sAnCd, iRvNo, iMtNo+1) = true then begin //ڷῡ ȣ ִ  Check
             PnNo.Caption   := IntToStr(iRvNo);
             PnJiNo.Caption := IntToStr(iMtNo);
             Result := True;
           end
           else if AucMeatGetRvNo(sOnCd, sDate, sAnCd, iRvNo+1) = true then begin
             if AucMeatGetMtNo(sOnCd, sDate, sAnCd, iRvNo, iMtNo) = true then begin
               PnNo.Caption := IntToStr(iRvNo);
               PnJiNo.Caption := IntToStr(iMtNo);
               Result := True;
             end
             else begin
               PnNo.Caption := IntToStr(iRvNo);
               PnJiNo.Caption := '0';
               ShowMessage(' ȣ : '+ IntToStr(iRvNo) +' ̻ ֽϴ. ȮϽʽÿ');
               Result := False;
             end;
           end
           else begin
             ShowMessage('۾ ϷǾϴ.');
             PnNo.Caption := IntToStr(iRvNo);
             PnJiNo.Caption := IntToStr(iMtNo);
             Result := False;
           end;
         end
         else begin
           PnNo.Caption := IntToStr(iRvNo);
           PnJiNo.Caption := '0';
           ShowMessage('± ȣ' + IntToStr(iRvNo) + '  ȣ̻!');
           Result := False;
         end;
      end
      else begin
        PnNo.Caption := IntToStr(iRvNo);
        PnJiNo.Caption := '0';
        ShowMessage('± ȣ' + IntToStr(iRvNo) + '  ȣ̻!');
        Result := False;
      end;
    end
    else if AucMeatGetRvNo(sOnCd, sDate, sAnCd, iRvNo+1) = true then begin  // ± ȣ +1    ڷ 
      if AucMeatGetMtNo(sOnCd, sDate, sAnCd, iRvNo, iMtNo) = true then begin
        PnNo.Caption := IntToStr(iRvNo);
        PnJiNo.Caption := IntToStr(iMtNo);
        Result := True;
      end
      else begin
        PnNo.Caption := IntToStr(iRvNo);
        PnJiNo.Caption := '0';
        ShowMessage('± ȣ' + IntToStr(iRvNo) + '  ȣ̻!');
        Result := False;
      end;
    end
    else begin
      Result := False;
      PnNo.Caption := IntToStr(iRvNo);
      PnJiNo.Caption := IntToStr(iMtNo);
      ShowMessage('۾ ϷǾϴ.');
    end;
  end
  else begin       //   ȣ ȣ  ū ƴ 
    if AucTagGetExMtNo(sOncd, sDate, sAnCd ,iRvNo, iMtNo+1) = true then begin //ȣ +1Ѱ ± ϸ
//      if LeftRightCheck(sOnCd, sDate, sAnCd, iRvNo, iMtNo) = true then begin  // , Ͽ ʿ 
      if AucTagGetRvNo(sOnCd, sDate, sAnCd, iRvNo+1) = true then begin  // ± ȣ  ū 
        if AucTagGetMtNo(sOnCd, sDate, sAnCd, iRvNo, iMtNo) = true then begin // ° ȣ  ū 
          if AucMeatGetMtNo(sOnCd, sDate, sAnCd, iRvNo, iMtNo+1) = true then begin // ȣ 
            PnNo.Caption := IntToStr(iRvNo);
            PnJiNo.Caption := IntToStr(iMtNo);
            Result := True;
          end
          else if AucMeatGetRvNo(sOnCd, sDate, sAnCd, iRvNo+1) = true then begin
            if AucMeatGetMtNo(sOnCd, sDate, sAnCd, iRvNo, iMtNo+1) = true then begin
              PnNo.Caption := IntToStr(iRvNo);
              PnJiNo.Caption := IntToStr(iMtNo);
              Result := True;
            end
            else begin
              PnNo.Caption := IntToStr(iRvNo);
              PnJiNo.Caption := '0';
              ShowMessage(' ȣ : '+ IntToStr(iRvNo) +' ̻ ֽϴ. ȮϽʽÿ');
              Result := False;
            end;
          end
          else begin
            Result := False;
            PnNo.Caption := IntToStr(iRvNo);
            PnJiNo.Caption := IntToStr(iMtNo);
            ShowMessage('۾ ϷǾϴ.');
          end;
        end
        else begin
          PnNo.Caption := IntToStr(iRvNo);
          PnJiNo.Caption := '0';
          ShowMessage('± ȣ' + IntToStr(iRvNo) + '  ȣ̻!');
          Result := False;
        end;
      end
      else if AucMeatGetRvNo(sOnCd, sDate, sAnCd, iRvNo+1) = true then begin
        if AucMeatGetMtNo(sOnCd, sDate, sAnCd, iRvNo, iMtNo+1) = true then begin
          PnNo.Caption := IntToStr(iRvNo);
          PnJiNo.Caption := IntToStr(iMtNo);
          Result := True;
        end
        else begin
          PnNo.Caption := IntToStr(iRvNo);
          PnJiNo.Caption := '0';
          ShowMessage(' ȣ : '+ IntToStr(iRvNo) +' ̻ ֽϴ. ȮϽʽÿ');
          Result := False;
        end;
      end
      else begin
        Result := False;
        PnNo.Caption := IntToStr(iRvNo);
        PnJiNo.Caption := IntToStr(iMtNo);
        ShowMessage('۾ ϷǾϴ.');
      end;
    end
    else if AucMeatGetMtNo(sOnCd, sDate, sAnCd, iRvNo, iMtNo+1) = true then begin
      PnNo.Caption := IntToStr(iRvNo);
      PnJiNo.Caption := IntToStr(iMtNo);
      Result := True;
    end
    else begin
      PnNo.Caption := IntToStr(iRvNo);
      PnJiNo.Caption := '0';
      ShowMessage(' ȣ : '+ IntToStr(iRvNo) +' ̻ ֽϴ. ȮϽʽÿ');
      Result := False;
    end;
  end;
end;

procedure TfrmCow_F.DataExCheck;
var
  sRvNo, sMtNo, sDate : String;
begin
  sRvNo := Trim(PnNo.Caption);    // ȣ
  sMtNo := Trim(PnJiNo.Caption);  // ȣ
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select kill_ymd, receive_no, mt_no from auctag ' +
            ' where online_cd  = :oncd             ' +
            '   and kill_ymd   = :ymd              ' +
            '   and animal_cd  = :ancd             ' +
            '   and receive_no = :rvno             ' +
            '   and mt_no      = :mtno             ' +
            '   and lr_gb      = :lrgb             ');
    ParamByName('oncd').AsString := sOnCd;
    ParamByName('ymd' ).AsString := sDate;
    ParamByName('ancd').AsString := sAnCd;
    ParamByName('rvno').AsInteger := StrToint(sRvNo);
    ParamByName('mtno').AsInteger := StrToInt(sMtNo);
    ParamByName('lrgb').AsString := sLrGb;
    Open;
    if not eof then begin
      with QryTemp1 do begin
        Close;
        Sql.Clear;
        Sql.Add(' update auctag                       ' +
                '    set kill_ymd = null,             ' +
                '        receive_no = null,           ' +
                '        mt_no      = null            ' +
                '  where online_cd = :oncd            ' +
                '    and kill_ymd = :ymd              ' +
                '    and animal_cd  = :ancd           ' +
                '    and receive_no = :rvno           ' +
                '    and mt_no      = :mtno           ');
        ParamByName('oncd').AsString := sOnCd;
        ParamByName('ymd' ).AsString := sDate;
        ParamByName('ancd').AsString := sAnCd;
        ParamByName('rvno').AsInteger := StrToInt(sRvNo);
        ParamByName('mtno').AsInteger := StrToInt(sMtNo);
        PrePare;
        ExecSql;
      end;
    end;
  end;
end;

procedure TfrmCow_F.InsertAucTag;
var
  sRvNo, sMtNo, sDate, sInputGb : String;
  dDate : TDateTime;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  sRvNo := Trim(PnNo.Caption);    // ȣ
  sMtNo := Trim(PnJiNo.Caption);  // ȣ
  sTagNo := Trim(edTagNo.Text);   // ±׹ȣ
  dDate := udGetSysDate;
  sInputGb := 'I';  // T:± H:
  If sRvNo <> '' Then Begin
  if sMtNo <> '' then begin
     With QryTemp Do Begin
       Close;
       Sql.Clear;
       Sql.Add('select online_cd from auctag        ' +
               ' where online_cd  = :oncd           ' +
               '   and tag_no     = :tag_no         ');
       ParamByName('tag_no').AsString := sTagNo;
       ParamByName('oncd').AsInteger  := StrToInt(sOnCd);
       Open;
       If Not Eof Then begin
         Close;
         Sql.Clear;
         Sql.Add('update auctag                     ' +
                 '   set kill_ymd  = :ymd,          ' +
                 '       animal_cd = :ancd,         ' +
                 '       mt_no     = :mtno,         ' +
                 '       receive_no = :rvno,        ' +
                 '       lr_gb     = :lrgb,         ' +
                 '       weight    = 0    ,         ' +
                 '       trans_dt  = null ,         ' +
                 '       trans_gb  = ''0'',         ' +
                 '       oper_dt   = :operdt,       ' +
                 '       oper_nm   = :opernm,       ' +
                 '       input_gb  = :inpgb         ' +
                 ' where online_cd = :oncd          ' +
                 '   and tag_no    = :tag_no        ');
         ParamByName('ymd').AsString    := sDate;
         ParamByName('ancd').AsString   := sAnCd;
         ParamByName('mtno').AsInteger  := StrToInt(sMtNo);
         ParamByName('rvno').AsInteger  := StrToInt(sRvNo);
         ParamByName('lrgb').AsString   := sLrGb;
         ParamByName('operdt').AsDateTime := dDate;
         ParamByName('opernm').AsString := gsUserName;
         ParamByName('inpgb').AsString  := sInputGb;
         ParamByName('tag_no').AsString := sTagNo;
         ParamByName('oncd').AsInteger  := StrToInt(sOnCd);
         PrePare;
         ExecSql;
       End
       Else Begin
         Close;
         Sql.Clear;
         Sql.Add('Insert Into auctag                                           ' +
                 ' (online_cd, tag_no, kill_ymd, animal_cd, mt_no, receive_no, ' +
                 '  lr_gb, oper_dt, oper_nm, input_gb)                         ' +
                 'values (:oncd, :tag_no, :ymd, :anicd, :mtno, :rvno,          ' +
                 '  :lrgb, :opdt, :opnm, :iptgb)                               ' );
         ParamByName('oncd').AsInteger  := StrToInt(sOnCd);
         ParamByName('tag_no').AsString := sTagNo;
         ParamByName('ymd').AsString    := sDate;
         ParamByName('anicd').AsString  := sAnCd;
         ParamByName('mtno').AsInteger  := StrToInt(sMtNo);
         ParamByName('rvno').AsInteger  := StrToInt(sRvNo);
         ParamByName('lrgb').AsString   := sLrGb;
         ParamByName('opdt').AsDateTime := dDate;
         ParamByName('opnm').AsString   := gsUserName;
         ParamByName('iptgb').AsString  := sInputGb;
         prepare;
         ExecSql;
       End;
     End;
  end
  else begin
     ShowMessage('ȣ ԷϽʽÿ!');
  end;    // if smtno <> '' end.
  End
  Else Begin
     ShowMessage('ȣ ԷϽʽÿ!');
  End;   // if srvno <> ''  end.
end;

procedure TfrmCow_F.InsertAucLogTag;
var
  sDate, sMtNo, sRvNo, sInputGb : String;
  dDate : TDateTime;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  sRvNo := Trim(PnNo.Caption);  // ȣ
  sMtNo := Trim(PnJiNo.Caption);  // ȣ
  dDate := udGetSysDate;
  sInputGb := 'I';  // T:± H:
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' insert into auclogtag                                            ' +
            ' (online_cd, tag_no, trans_dt, kill_ymd, mt_no, receive_no,       ' +
            '  animal_cd, lr_gb, oper_id, input_gb, log_gb )                   ' +
            ' values (:oncd, :tagno, :trsdt, :ymd, :mtno, :rvno,               ' +
            '         :ancd, :lrgb, :operid, :inpgb, :loggb )                  ' );
    ParamByName('oncd').AsInteger   := StrToInt(sOnCd);
    ParamByName('tagno').AsString   := sTagNo;
    ParamByName('trsdt').AsDateTime := dDate;
    ParamByName('ancd').AsString    := sAnCd;
    ParamByName('lrgb').AsString    := sLrGb;
    ParamByName('ymd').AsString     := sDate;
    ParamByName('mtno').AsInteger   := StrToInt(sMtNo);
    ParamByName('rvno').AsInteger   := StrToInt(sRvNo);
    ParamByName('operid').AsString  := gsUserId;
    ParamByName('inpgb').AsString   := sInputGb;
    ParamByName('loggb').AsString   := 'I';
    PrePare;
    ExecSql;
  end;
end;
procedure TfrmCow_F.dtdateExit(Sender: TObject);
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);

  if GetMinMaxRvNo(sOnCd, sDate, sAnCd) then begin
    PnStNo.Caption := IntToStr(iMinRvNo);
    PnEdNo.Caption := IntToStr(iMaxRvNo);
  end
  else begin
    PnStNo.Caption := '0';
    PnEdNo.Caption := '0';
  end;

  iTotalCnt := GetTotalCnt;
  iWorkCnt  := GetInputCnt;
  PnMsg2.Caption := ' : ' + IntToStr(iTotalCnt - iWorkCnt);
  PnMsg1.Caption := ' : ' + IntToStr(iWorkCnt);
end;

//  ̺ ǰ ڵ忡  ڷ 
Function TfrmCow_F.getCommon(in_main_cd, in_sub_cd : String) : String;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add('select desc1 from auccommon                   ' +
            ' where main_cd = :main_cd                     ' +
            '   and sub_cd  = :sub_cd                      ');
    ParamByName('main_cd').AsString := in_main_cd;
    ParamByName('sub_cd').AsString := in_sub_cd;
    Open;
    if Not Eof then begin
       result := FieldByName('desc1').AsString;
    end
    else result := '';
  end;
end;

procedure TfrmCow_F.SerialInit;
begin
  TimeCnt := 0;
  TmConnect.Interval := 1000;
  TmConnect.Enabled := True;
  SendPacket(CMD_STATE, ID_CONTROLLER, [$00], 0);
end;

procedure TfrmCow_F.CmPtRxChar(Sender: TObject; Count: Integer);
var
  Cnt, i : Integer;
  TmpBuf : array[0..MAX_SIZE-1] of Byte;
begin
  Cnt := 0;
  FillChar(TmpBuf, MAX_SIZE, $00);
  Cnt := CmPt.Read(TmpBuf, Count);
  if(Cnt <= 0) then Exit;

  if TimeCnt <= 3 then begin
     TmConnect.Enabled := False;
     TimeCnt := 0;
  end;

  for i:=0 to Cnt-1 do
  begin
    case TmpBuf[i] of
      _STX:
        begin
          pIdx:= 0;
          pBuf[pIdx] := _STX;
          Inc(pIdx);
        end;
      _ETX:
        begin
          pBuf[pIdx] := _ETX;
          Inc(pIdx);
        end;
      else
        begin
          pBuf[pIdx] := TmpBuf[i];
          inc(pIdx);

          if(pIdx >= MAX_SIZE) then
          begin
            pIdx := 0;
          end else if(pBuf[pIdx-2] = _ETX) then
          begin
            NotificationHandler(pBuf, pIdx);
            pIdx := 0;
          end;
        end;
    end; // case..end
  end;
end;

function TfrmCow_F.SendPacket(cmd, id: byte; buf: array of byte;
            len: Integer): Integer;
var
  i,x: integer;
  bcc: byte;
  tx: array[0..250] of byte;
  s: string;
begin
  Result:= 0;
  if not CmPt.Connected then  Exit;

  x:= 0;
  tx[x]:= _STX;   Inc(x);
  tx[x]:= cmd;    Inc(x);
  tx[x]:= id;     Inc(x);

  move(buf, tx[x], len);
  Inc(x, len);

  tx[x]:= _ETX;   Inc(x);

  bcc:= 0;
  for i:=0 to x-1 do
    bcc:= bcc xor tx[i];
  bcc:= bcc or $80;

  if(bcc = $FF) then
    bcc:= $7F;

  tx[x]:= bcc;      Inc(x);
  // Send
  Result:= CmPt.Write(tx, x);

  if(Result > 0) then
  begin
//    showmessage(Format('SEND[%0.2d]: %s', [x, ArrayToString(tx,x)]));
  end else begin
//    showmessage('SEND FAIL...');
  end;
end;

procedure TfrmCow_F.NotificationHandler(buf: array of byte; cnt: Integer);
var
  i, ii, jj: integer;
  bcc: byte;
  AckNak: byte;
  dump_s : string;
begin
  ii := 0;
  bcc:= 0;
  for i:=0 to cnt-2 do
    bcc:= bcc xor buf[i];
  bcc:= bcc or $80;
  if(bcc = $FF) then bcc:= $7F;

  if(bcc = buf[cnt-1]) then
  begin
    AckNak:= _ACK;
  end else begin
    AckNak:= _NAK;
  end;

  case buf[1] of
    CMD_STATE: // Controller Init
      begin
        if cnt = 5 then // CMD
          SendPacket(CMD_STATE, ID_CONTROLLER, [AckNak], 1);
      end;
    CMD_READER :
      begin
        dump_s := StringOfChar(' ', pidx );
        move(pbuf, pchar(dump_s)^, pidx );

        ii := pos(':', dump_s);
        sTagNo := copy(dump_s, ii+1, 11);
        edTagNo.Text := sTagNo;

        SendPacket(CMD_READER, ID_READER, [AckNak], 1);
      end;
    CMD_LAMP:
      begin
        if cnt = 5 then begin// CMD
          SendPacket(CMD_LAMP, ID_LAMP, [AckNak], 1);
        end;
      end;
    CMD_LIMIT:
      begin
        SendPacket(CMD_LIMIT, ID_LIMIT, [AckNak], 1);

        if Length(sTagNo) <= 0 then begin
          SendPacket(CMD_LAMP, ID_LAMP, [LP_RED], 1);
          TimeCnt := 0;
          TmLamp.Interval := 1000;
          TmLamp.Enabled := True;
        end
        else btnSav.Click;
        sTagNo := '';
        edTagNo.Text := '';
        FillChar(pbuf, MAX_SIZE, $00);
        pidx := 0;
      end;
    CMD_ERROR:
      begin
        showmessage('Ʈѷ κҸ, ι߻. Ʈѷ Ͻʽÿ!');
      end;
    else
      begin
        //
      end;
  end;
end;

function TfrmCow_F.ArrayToString(buf: array of byte; len: Integer): string;
var
  i: Integer;
begin
  result:= '';
  for I:=0 to (len-1) do
    result:= result + IntToHex(buf[i],2) + ' ';
end;

procedure TfrmCow_F.tmConnectTimer(Sender: TObject);
begin
  inc(TimeCnt);
  if TimeCnt > 3 then begin
     TmConnect.Enabled := False;
     TimeCnt := 0;
     showmessage('Ʈѷ ¸ ȮϽʽÿ!');
     exit;
  end;
end;

procedure TfrmCow_F.tmLampTimer(Sender: TObject);
var
  i : integer;
begin
  inc(TimeCnt);
  if TimeCnt > 10 then begin
    SendPacket(CMD_LAMP, ID_LAMP, [LP_OFF], 1);
    TmLamp.Enabled := False;
    TimeCnt := 0;
    exit;
  end
  else begin
    i := TimeCnt mod 2;
    if i = 0 then
        SendPacket(CMD_LAMP, ID_LAMP, [LP_RED], 1)
    else
        SendPacket(CMD_LAMP, ID_LAMP, [LP_OFF], 1);
  end;
end;

procedure TfrmCow_F.btnPumClick(Sender: TObject);
begin
  if sKnd_cd = '11' then
    sKnd_Cd := '12'
  else if sKnd_Cd = '12' then
    sKnd_cd := '13'
  else if sKnd_Cd = '13' then
    sKnd_cd := '14'
  else if sKnd_Cd = '14' then
    sKnd_cd := '19'
  else if sKnd_Cd = '19' then
    sKnd_cd := '21'
  else if sKnd_Cd = '21' then
    sKnd_cd := '22'
  else if sKnd_Cd = '22' then
    sKnd_cd := '23'
  else if sKnd_Cd = '23' then
    sKnd_cd := '24'
  else if sKnd_Cd = '24' then
    sKnd_cd := '11';

  PnPum.Caption := getCommon('18',sKnd_cd);

end;

procedure TfrmCow_F.btnSexClick(Sender: TObject);
begin
  if sSex_cd = '1' then
    sSex_Cd := '2'
  else if sSex_cd = '2' then
    sSex_Cd := '3'
  else if sSex_cd = '3' then
    sSex_Cd := '4'
  else if sSex_cd = '4' then
    sSex_Cd := '1';

  PnSex.Caption := getCommon('12',sSex_cd);
end;

end.
