unit Pig_F;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, RXCtrls, ToolWin, StdCtrls, Buttons, ExtCtrls,ShellApi,
  RxGIF, IniFiles, CPort, DB, DBTables, CPortCtl;

const
  CMD_STATE      = $61;  // 'a'  - ſ Ȯ
  CMD_LIMIT      = $62;  // 'b'  - Ʈ  
  CMD_READER     = $63;  // 'c'  - ˿
  CMD_LAMP       = $64;
  CMD_ERROR      = $65;

  ID_CONTROLLER  = $30;
  ID_READER      = $31;
  ID_LIMIT       = $32;
  ID_LAMP        = $33;

  LP_OFF         = $30;  // Lamp Off
  LP_RED         = $31;  // RED
  LP_BLUE        = $32;  // BLUE
  LP_ALL         = $33;  //   ON

  LIMIT_ON       = $31;  // '1'

  _STX           = $02;
  _ETX           = $03;
  _ACK           = $06;
  _NAK           = $15;

  MAX_SIZE       = 1024;

type
  TfrmPig_F = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    dtdate: TDateTimePicker;
    Image1: TImage;
    Image2: TImage;
    btnSch: TButton;
    btnClr: TButton;
    Panel7: TPanel;
    btn1: TButton;
    pnMsg1: TPanel;
    pnMsg2: TPanel;
    PnMsg3: TPanel;
    btn2: TButton;
    btn3: TButton;
    btn4: TButton;
    btn5: TButton;
    btn6: TButton;
    btn7: TButton;
    btn8: TButton;
    btn9: TButton;
    btn0: TButton;
    btnSav: TButton;
    btnExt: TButton;
    pnNo: TPanel;
    pnJiNo: TPanel;
    CmPt: TComPort;
    QryTemp: TQuery;
    QryTemp1: TQuery;
    tmConnect: TTimer;
    Panel11: TPanel;
    pnstno: TPanel;
    Panel13: TPanel;
    pnedno: TPanel;
    Panel15: TPanel;
    pnjistno: TPanel;
    Panel17: TPanel;
    pnjiedno: TPanel;
    Panel12: TPanel;
    edTagNo: TEdit;
    Panel8: TPanel;
    PnDonPi: TPanel;
    tmLamp: TTimer;
    Shape1: TShape;
    procedure btnExtClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ClearScreen;
    procedure FormCreate(Sender: TObject);
    procedure btn1Click(Sender: TObject);
    procedure pnNoClick(Sender: TObject);
    procedure pnJiNoClick(Sender: TObject);
    procedure pnDonPiClick(Sender: TObject);
    procedure btnClrClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image2Click(Sender: TObject);
    procedure btnSchClick(Sender: TObject);
    procedure btnSavClick(Sender: TObject);
    procedure InsertAucTag;
    procedure InsertAucLogTag;

    function  PortChk : Boolean;
    function  GetTotalCnt : Integer;
    function  GetInputCnt : Integer;
    function  GetMinMaxRvNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String) :boolean;
    function  GetMinMaxMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                            in_iRvNo:Integer) :boolean;
    function  GetRvMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                      in_iRvNo:Integer) : boolean;
    function  GetMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                           in_iRvNo : Integer) : boolean;
    function  GetMaxRvNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String) : boolean;
    procedure DataExCheck;

    procedure SerialInit;
    procedure CmPtRxChar(Sender: TObject; Count: Integer);
    procedure tmConnectTimer(Sender: TObject);
    procedure tmLampTimer(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure dtdateChange(Sender: TObject);
    procedure Panel12DblClick(Sender: TObject);
    procedure Panel12Exit(Sender: TObject);
    procedure pnNoDblClick(Sender: TObject);
    procedure pnJiNoDblClick(Sender: TObject);
    procedure PnDonPiDblClick(Sender: TObject);
    procedure FiFo(buf:array of string; in_tagno : String);
    function dupCheck(in_tagno:String) : Boolean;

  private
    { Private declarations }
    pBuf: array[0..MAX_SIZE-1] of Byte;
    tagBuf : array[0..9] of String;
    tagCnt : integer;
    pIdx: Integer;
    TimeCnt : DWord;

  public
    { Public declarations }
    procedure NotificationHandler(buf: array of byte; cnt: Integer);
    function SendPacket(cmd: byte; id: byte; buf:array of byte; len: Integer): Integer;

    function ArrayToString(buf:array of byte; len:Integer): string;

  end;

var
  frmPig_F: TfrmPig_F;

implementation

uses DM_F, Setup, TchLib;

Var InsertFlag : Boolean;
  sPort, sRate, sOnCd, sTagNo : String;
  pbDate, sAnCd, serr_text : String;
  iMtNo, iRvNo, iWorkCnt, iTotalCnt, iClickCnt, iLampTime : Integer;
  iflag,iMinRvNo, iMaxRvNo, iMinMtNo, iMaxMtNo : integer;

{$R *.dfm}

procedure TfrmPig_F.btnExtClick(Sender: TObject);
begin
  If Application.MessageBox('Ͻðڽϱ?', '',MB_YESNO) = IDYES then begin
     CmPt.Close;
     Close;
  end;
end;

procedure TfrmPig_F.FormKeyPress(Sender: TObject; var Key: Char);
begin
   If (Key = #13) Then
   Begin
      Key := #0;
      PerForm(WM_NEXTDLGCTL, 0, 0);
   End;
end;

procedure TfrmPig_F.ClearScreen;
var
  i : integer;
begin
  iFlag            := 1;
//  PnNo.Caption     := '';
  PnNo.Color       := $006FE6B0;
  PnJiNo.Color     := ClWhite;
  PnDonPi.Color    := ClWhite;
//  PnJiNo.Caption   := '';
//  PnJiStno.Caption := '0';
//  PnJiedno.Caption := '0';
  PnMsg3.Font.Color := clBlue;
  PnMsg3.Caption   := '';
//  PnDonPi.Caption  := '';
  edTagNo.Text     := '';
  for i:=0 to tagCnt do begin
    tagBuf[i] := '';
  end;
  tagCnt := 0;
end;

procedure TfrmPig_F.FormCreate(Sender: TObject);
begin
  iMtNo     := 0;   //  ʱȭ
  iRvNo     := 0;
  iTotalCnt := 0;   // ü ۾ 
  iWorkCnt  := 0;   //  ۾  
  iMinRvNo  := 0; iMaxRvNo := 0; iMinMtNo := 0; iMaxMtNo := 0;
  iClickCnt := 0;
  InsertFlag := True;
  sAnCd := '2';      //    1: 2:
  TmConnect.Enabled := false;  // Ʈѷ  Ȯϱ  Ÿ̸
  TmLamp.Enabled := false;     //  ON, OFF Ÿ̸
  edTagNo.Text := '';
  ClearScreen;                 // ȭ ʱȭ
  DateTimeToString(pbDate, 'YYYY-MM-DD', gdDate);

  DtDate.Date      := StrToDateTime(pbDate);

 //  αν Ʈ üũ
  If PortChk = False then begin  // Ʈ    Setup ȭ Display
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
  end;

  if GetMaxRvNo(sOnCd, pbDate, sAnCd) = true then begin
    if GetRvMtNo(sOnCd, pbDate, sAnCd, iRvNo) = true then begin
      PnNo.Caption   := IntToStr(iRvNo);
      PnJiNo.Caption := IntToStr(iMtNo);
    end
    else begin
      ShowMessage(' ȣ ۾ ϷǾ!');
      PnNo.Caption := IntToStr(iRvNo);
    end;
  end
  else begin
    if GetRvMtNo(sOnCd, pbDate, sAnCd, iRvNo) = true then begin
      PnNo.Caption   := IntToStr(iRvNo);
      PnJiNo.Caption := IntToStr(iMtNo);
    end
    else begin
      ShowMessage('ڷᰡ ϴ! ȮϽʽÿ!');
    end;
  end;

  if GetMinMaxRvNo(sOnCd, pbDate, sAnCd) = true then begin
    PnStNo.Caption := IntToStr(iMinRvNo);
    PnEdNo.Caption := IntToStr(iMaxRvNo);
  end
  else begin
    PnStNo.Caption := '0';
    PnEdNo.Caption := '0';
  end;

  if GetMinMaxMtNo(sOnCd, pbDate, sAncd, iRvNo) = true then begin
    PnJiStNo.Caption := IntToStr(iMinMtNo);
    PnJiEdNo.Caption := IntToStr(iMaxMtNo);
  end
  else begin
    PnJiStNo.Caption := '0';
    PnJiEdNo.Caption := '0';
  end;

  SerialInit;     // α׷ ۽ Ʈѷ  Ȯ
  iTotalCnt := GetTotalCnt;
  iWorkCnt  := GetInputCnt;
  PnMsg2.Caption := ' : ' + IntToStr(iTotalCnt - iWorkCnt);
  PnMsg1.Caption := ' : ' + IntToStr(iWorkCnt);
end;

Function TfrmPig_F.PortChk : Boolean;
Var MyIni : TIniFile;
    sSysPath : String;
Begin
  CmPt.Open;

  if Not CmPt.Connected then
     result := false
  else
     result := true;

  sSysPath := GetCurrentDir + '\Setup.ini';
  MyIni := TIniFile.Create(sSysPath);
  If FileExists(sSysPath) = False Then Begin
     Result := false;
     Exit;
  end
  else begin
    sPort := MyIni.ReadString('ȯ漳', 'PORT', '');
    sRate := MyIni.ReadString('ȯ漳', 'SPEED', '');
    sOnCd  := MyIni.ReadString('ȯ漳', 'ONLINECODE', '');
    iLampTime := MyIni.ReadInteger('ȯ漳', 'LAMP', 0);
  // Ʈѷ Ʈ  üũ
    Case StrToInt(sPort) Of     // Ʈѷ Ʈȣ
      0 : begin
            CmPt.Port := 'COM1';
          end;
      1 : begin
            CmPt.Port := 'COM2';
          end;
      2 : begin
            CmPt.Port := 'COM3';
          end;
      3 : begin
            CmPt.Port := 'COM4';
          end;
    End;

    Case StrToInt(sRate) Of   // ѷ Ʈӵ
       0 : begin
             CmPt.BaudRate      := br2400;
           end;
       1 : begin
             CmPt.BaudRate      := br4800;
           end;
       2 : begin
             CmPt.BaudRate      := br9600;
           end;
       3 : begin
             CmPt.BaudRate      := br14400;
           end;
       4 : begin
             CmPt.BaudRate      := br19200;
           end;
       5 : begin
             CmPt.BaudRate      := br38400;
           end;
       6 : begin
             CmPt.BaudRate      := br56000;
           end;
    End;
  end;
End;

procedure TfrmPig_F.btn1Click(Sender: TObject);
begin
  if iflag = 1 Then Begin  // Է Ŀ ȣ ϶
    PnNo.Caption := PnNo.Caption + (Sender As TButton).Caption;
    If Length(PnNo.Caption) > 4 Then begin
       ShowMessage('ϵ ȣʰ!');
       PnNo.Caption := copy(PnNo.Caption, 0, 4);
    end;
  End
  Else if iflag = 2 then begin    // Է Ŀ ȣ ϶
    If PnNo.Caption <> '' Then Begin
       PnJiNO.Caption := PnJiNo.Caption + (Sender As TButton).Caption;
       if Length(PnJiNo.Caption) > 4 then begin
          ShowMessage('ϵ ȣ ʰ!');
          PnJiNo.Caption := Copy(PnJiNo.Caption, 0, 4);
       end;
    End
    Else
    Begin
       ShowMessage(' ȣ ԷϽʽÿ!');
       ClearScreen;
    End;
  end
  else begin
    if (Sender As TButton).Caption = '1' then begin
      PnDonPi.Caption := '';
    end;

    if (Sender As TButton).Caption = '2' then begin
      PnDonPi.Caption := '';
    end;
    
    if Not ((PnDonPi.Caption = '') or (PnDonPi.Caption = '')) then begin
      PnDonPi.Caption := '';
      ShowMessage('Ǳ 1: 2: Դϴ. ȮϽʽÿ!');
      exit;
    end;

    If Length(PnDonPi.Caption) > 5 Then begin
       ShowMessage('ϵ ȣʰ!');
       PnDonPi.Caption := copy(PnDonPi.Caption, 0, 1);
    end;
  end;
end;

procedure TfrmPig_F.pnNoClick(Sender: TObject);
begin
  iFlag := 1;
//  PnNo.Caption := '';
  PnNo.Color := $006FE6B0;
  PnJiNo.Color := ClWhite;
  PnDonPi.Color := ClWhite;
end;

procedure TfrmPig_F.pnJiNoClick(Sender: TObject);
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);

  iFlag := 2;
//  PnJiNo.Caption := '';
  PnNo.Color := ClWhite;
  PnDonPi.Color := ClWhite;
  PnJiNo.Color := $006FE6B0;
  if ((Trim(PnNo.Caption) = '') or (Trim(PnNo.Caption) = '0')) then begin
  end
  else begin
    iRvNo := StrToInt(Trim(PnNo.Caption));
    if GetMinMaxMtNo(sOnCd, sDate, sAncd, iRvNo) = true then begin
       PnJiStNo.Caption := IntToStr(iMinMtNo);
       PnJiEdNo.Caption := IntToStr(iMaxMtNo);
    end
    else begin
       PnJiStNo.Caption := '0';
       PnJiEdNo.Caption := '0';
    end;
  end;
end;

procedure TfrmPig_F.pnDonPiClick(Sender: TObject);
begin
  iFlag := 3;
//  PnDonPi.Caption := '';
  PnNo.Color    := ClWhite;
  PnJiNo.Color  := ClWhite;
  PnDonPi.Color := $006FE6B0;
end;

procedure TfrmPig_F.btnClrClick(Sender: TObject);
begin
  ClearScreen;
  btnSav.Enabled := True;
end;

procedure TfrmPig_F.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   If (Shift = [ssShift, ssAlt]) and (Key = VK_F1) Then
   Begin
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
   End;

   If PortChk = False then begin  // Ʈ    Setup ȭ Display
      frmSetup := TfrmSetup.Create(Application);
      frmSetup.ShowModal;
   end;
end;

procedure TfrmPig_F.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CmPt.Close;
  Action := CaFree;
end;

procedure TfrmPig_F.Image2Click(Sender: TObject);
begin
  If PnNo.Caption = '0000' then begin
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
  end;

  If PortChk = False then begin  // Ʈ    Setup ȭ Display
     frmSetup := TfrmSetup.Create(Application);
     frmSetup.ShowModal;
  end;
end;

Function TfrmPig_F.GetTotalCnt : Integer;
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select count(distinct mt_no) cnt from aucmeat ' +
            '  where online_cd = :oncd                  ' +
            '    and kill_ymd  = :ymd                   ' +
            '    and animal_cd = :ancd                  ' +
            '    and mt_no     < 8000                   ' +
            '    and io_gb     <> ''32''                ');
    ParamByName('oncd').AsInteger := StrToInt(sOnCd);
    ParamByName('ymd').AsString   := sDate;
    ParamByName('ancd').AsString  := sAnCd;
    Open;
    if Not Eof then
       Result := FieldByName('cnt').AsInteger
    else Result := 0;
    close;
  end;
end;

Function TfrmPig_F.GetInPutCnt : Integer;
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select count(distinct mt_no) cnt from auctag ' +
            '  where online_cd = :oncd                  ' +
            '    and kill_ymd  = :ymd                   ' +
            '    and animal_cd = :ancd                  ' +
            '    and mt_no     < 8000                   ' );
    ParamByName('oncd').AsInteger := StrToInt(sOnCd);
    ParamByName('ymd').AsString   := sDate;
    ParamByName('ancd').AsString  := sAnCd;
    Open;
    if Not Eof then
       Result := FieldByName('cnt').AsInteger
    else Result := 0;
    close;
  end;
end;

function TfrmPig_F.GetMinMaxRvNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String) : boolean;
begin
  With QryTemp Do Begin
    Close;
    Sql.Clear;
    Sql.Add(' select min(receive_no) min_rv_no,           ' +
            '        max(receive_no) max_rv_no            ' +
            '   from aucmeat                              ' +
            '  where online_cd = :oncd                    ' +
            '    and kill_ymd  = :ymd                     ' +
            '    and animal_cd = :sAnCd                   ' +
            '    and mt_no     < 8000                     ' +
            '    and io_gb     <> ''32''                  ');
    ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd').AsString   := in_Kill_Ymd;
    ParamByName('sAnCd').AsString := In_sAnCd;
    Open;
    if Not eof then begin
      iMinRvNo := FieldByName('min_rv_no').AsInteger;
      iMaxRvNo := FieldByName('max_rv_no').AsInteger;
      Result := True;
    end
    else begin
      iMinRvNo := 0;
      iMaxRvNo := 0;
      Result := False;
    end;
    close;
  end;
end;

function TfrmPig_F.GetMinMaxMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                                 in_iRvNo : Integer) : Boolean;
begin
  If in_iRvNo >= 0 then begin
     With QryTemp Do Begin
       Close;
       Sql.Clear;
       Sql.Add(' select min(mt_no) min_mt_no,                ' +
               '        max(mt_no) max_mt_no                 ' +
               '   from aucmeat                              ' +
               '  where online_cd = :oncd                    ' +
               '    and kill_ymd  = :ymd                     ' +
               '    and animal_cd = :sAnCd                   ' +
               '    and mt_no     < 8000                     ' +
               '    and io_gb     <> ''32''                  ' +
               '    and receive_no = :rcvno                  ' +
               '  group by receive_no                        ' );
       ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
       ParamByName('ymd').AsString   := in_Kill_Ymd;
       ParamByName('sAnCd').AsString   := in_sAnCd;
       ParamByName('rcvno').AsInteger := in_iRvNo;
       Open;
       if Not eof then begin
         iMinMtNo := FieldByName('min_mt_no').AsInteger;
         iMaxMtNo := FieldByName('max_mt_no').AsInteger;
         Result := true;
       end
       else begin
         iMinMtNo := 0;
         iMaxMtNo := 0;
         Result := false;
       end;
       close;
     end;
  end
  else begin
    ShowMessage('ȣ ԷϽʽÿ!');
  end;
end;

function TfrmPig_F.GetRvMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                           in_iRvNo : Integer) : boolean;
var
  sDonPi : String;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add('select a.receive_no rvno, a.mt_no mtno   ' +
            '  from aucmeat a                         ' +
            ' where online_cd  = :OnCd                ' +
            '   and kill_ymd   = :ymd                 ' +
            '   and mt_no      < 8000                 ' +
            '   and receive_no >= :rvno               ' +
            '   and mt_no not in                      ' +
            '       (select mt_no                     ' +
            '          from auctag                    ' +
            '         where online_cd  = a.online_cd  ' +
            '           and kill_ymd   = a.kill_ymd   ' +
            '           and receive_no = a.receive_no ' +
            '           and mt_no      = a.mt_no      ' +
            '           and animal_cd  = a.animal_cd )' +
            '   and animal_cd =  :ancd                ' +
            '   and io_gb     <> ''32''               ' +
            ' group by a.receive_no, a.mt_no          ' +
            ' order by receive_no, a.mt_no            ');
    ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd' ).AsString  := in_kill_ymd;
    ParamByName('ancd').AsString  := in_sAnCd;
    ParamByName('rvno').AsInteger := in_iRvNo;
    Open;
    First;
    if Not Eof then begin
      iRvNo := FieldByName('rvno').AsInteger;
      iMtNo := FieldByName('mtno').AsInteger;
      Result := True;
      with QryTemp1 do begin  // Ǳ 
        Close;
        Sql.Clear;
        Sql.Add(' select donpi from aucmeat              ' +
                '  where online_cd = :oncd               ' +
                '    and kill_ymd  = :ymd                ' +
                '    and animal_cd = ''2''               ' +
                '    and mt_no     = :mtno               ' +
                '    and io_gb     <> ''32''             ' +
                '    and receive_no = :rvno              ' );
        ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
        ParamByName('ymd').AsString   := In_Kill_Ymd;
        ParamByName('mtno').AsInteger := iMtNo;
        ParamByName('rvno').AsInteger := iRvNo;
        Open;
        if Not Eof then begin
           sDonPi := FieldByName('donpi').AsString;
           if sDonPi = '1' then
              PnDonPi.Caption := ''
           else if sDonPi = '2' then
              PnDonPi.Caption := ''
           else PnDonPi.Caption := '';
        end
        else begin
          PnDonPi.Caption := '';
          showmessage('Ǳ ڵ尡  ʽϴ.  ԷϽʽÿ!');
          PnDonPi.SetFocus;
        end;
        close;
      end;
    end
    else begin
      Result := False;
    end;
    close;
  end;
end;

function TfrmPig_F.GetMtNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String;
                           in_iRvNo : Integer) : boolean;
var
  sDonPi : String;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add('select min(a.mt_no) mtno                 ' +
            '  from aucmeat a                         ' +
            ' where online_cd  = :OnCd                ' +
            '   and kill_ymd   = :ymd                 ' +
            '   and receive_no = :rvno                ' +
            '   and mt_no      < 8000                 ' +
            '   and mt_no not in                      ' +
            '       (select mt_no                     ' +
            '          from auctag                    ' +
            '         where online_cd  = a.online_cd  ' +
            '           and kill_ymd   = a.kill_ymd   ' +
            '           and receive_no = a.receive_no ' +
            '           and animal_cd  = a.animal_cd )' +
            '   and animal_cd =  :ancd                ' +
            '   and io_gb     <> ''32''               ');
    ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd' ).AsString  := in_kill_ymd;
    ParamByName('ancd').AsString  := in_sAnCd;
    ParamByName('rvno').AsInteger := in_iRvNo;
    Open;
    if FieldByName('mtno').AsInteger > 0 then begin
      iMtNo := FieldByName('mtno').AsInteger;
      Result := True;
      with QryTemp1 do begin  // Ǳ 
        Close;
        Sql.Clear;
        Sql.Add(' select donpi from aucmeat              ' +
                '  where online_cd = :oncd               ' +
                '    and kill_ymd  = :ymd                ' +
                '    and animal_cd = ''2''               ' +
                '    and mt_no     = :mtno               ' +
                '    and io_gb     <> ''32''             ' +
                '    and receive_no = :rvno              ' );
        ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
        ParamByName('ymd').AsString   := In_Kill_Ymd;
        ParamByName('mtno').AsInteger := iMtNo;
        ParamByName('rvno').AsInteger := in_iRvNo;
        Open;
        if Not Eof then begin
           sDonPi := FieldByName('donpi').AsString;
           if sDonPi = '1' then
              PnDonPi.Caption := ''
           else if sDonPi = '2' then
              PnDonPi.Caption := ''
           else PnDonPi.Caption := '';
        end
        else begin
          PnDonPi.Caption := '';
          showmessage('Ǳ ڵ尡  ʽϴ.  ԷϽʽÿ!');
          PnDonPi.SetFocus;
        end;
        close;
      end;
    end
    else begin
      Result := False;
    end;
    close;
  end;
end;

function TfrmPig_F.GetMaxRvNo(in_sOnCd, in_Kill_Ymd, in_sAnCd : String) : boolean;
begin
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add('select max(receive_no) rvno              ' +
            '  from auctag                            ' +
            ' where online_cd  = :OnCd                ' +
            '   and kill_ymd   = :ymd                 ' +
            '   and animal_cd =  :ancd                ');
    ParamByName('oncd').AsInteger := StrToInt(in_sOnCd);
    ParamByName('ymd' ).AsString  := in_kill_ymd;
    ParamByName('ancd').AsString  := in_sAnCd;
    Open;
    if FieldByName('rvno').AsInteger > 0 then begin
      iRvNo := FieldByName('rvno').AsInteger;
      Result := True;
    end
    else begin
      iRvNo := 0;
      Result := False;
    end;
    close;
  end;
end;

procedure TfrmPig_F.btnSchClick(Sender: TObject);
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);

  if ((Trim(PnNo.Caption) = '') or (Trim(PnNo.Caption) = '0')) then begin
    ShowMessage('ȣ ԷϽʽÿ!');
    exit;
  end
  else begin
    iRvNo := StrToInt(Trim(PnNo.Caption));
  end;

  if GetMtNo(sOnCd, sDate, sAnCd, iRvNo) = True then begin
    PnJiNo.Caption := IntToStr(iMtNo);
  end
  else begin
      ShowMessage('ȣ : ' + IntToStr(iRvNo) + ' ۾ ϷǾϴ!');
      PnJiNo.Caption := '0';
  end;

  if GetMinMaxMtNo(sOnCd, sDate, sAncd, iRvNo) = true then begin
    PnJiStNo.Caption := IntToStr(iMinMtNo);
    PnJiEdNo.Caption := IntToStr(iMaxMtNo);
  end
  else begin
    PnJiStNo.Caption := '0';
    PnJiEdNo.Caption := '0';
  end;
end;

procedure TfrmPig_F.btnSavClick(Sender: TObject);
var
  sTag_No, sDate : String;
  iTemp : Integer;
begin
  iRvNo := StrToInt(PnNo.Caption);
  iMtNo := StrToInt(PnJiNo.Caption);

  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  sTag_No := Trim(edTagNo.Text);

  if ((Trim(PnNo.Caption) = '') or (StrToInt(PnNo.Caption) = 0)) then begin
    showmessage('ȣ ԷϽʽÿ!');
    exit;
  end;

  if ((Trim(PnJiNo.Caption) = '') or (StrToInt(PnJiNo.Caption) = 0)) then begin
    showmessage(' ȣ ԷϽʽÿ!');
    exit;
  end;

  if Length(sTag_No) <> 11 then begin
    ShowMessage('Էµ ±׹ȣ ȮϽʽÿ!');
    exit;
  end;

  if gf_PubQry(' select mt_no                       ' +
               '   from auctag                      ' +
               '  where online_cd = ''' +sOnCd+  '''' +
               '    and kill_ymd  = ''' +sDate+  '''' +
               '    and animal_cd = ''' +sAnCd+  '''' +
               '    and receive_no = ''' + IntToStr(iRvNo)+'''' +
               '    and mt_no      = ''' + IntToStr(iMtNo)+'''' ) > 0 then begin
    If Application.MessageBox('± ϵǾ ֽϴ. ۾  Ͻðڽϱ?',
       '۾', MB_YESNO) <> IDYES then begin
       PnMsg3.Font.Color := clBlue;
       PnMsg3.Caption := '';
       exit;
    end;
  end;

  if gf_PubQry('select tag_no from auctag            '+
               ' where online_cd = '''+ sOnCd  + ''' '+
               '   and tag_no    = '''+ sTag_No + ''' '+
               '   and kill_ymd  = '''+ sDate  + ''' ') > 0 then begin
    If Application.MessageBox('± ڷᰡ ϵǾ ֽϴ. ۾  Ͻðڽϱ?',
                              '۾', MB_YESNO) <> IDYES then begin
       PnMsg3.Font.Color := clBlue;
       PnMsg3.Caption := '';
       exit;
    end;
  end;

  With Dm_Grd do begin // 
    Try
      PnMsg3.Caption := '';
      PnMsg3.Font.Color := clGreen;

      DataBase.StartTransaction;
      DataExCheck;
      InsertAucTag;
      InsertAucLogTag;
      DataBase.Commit;

      iRvNo := StrToInt(Trim(PnNo.Caption));
      iMtNo := StrToInt(Trim(PnJiNo.Caption));

      if GetRvMtNo(sOnCd, sDate, sAnCd, iRvNo) = True then begin
        PnNo.Caption := IntToStr(iRvNo);
        PnJiNo.Caption := IntToStr(iMtNo);
        iTotalCnt := GetTotalCnt;
        iWorkCnt  := GetInputCnt;
        PnMsg2.Caption := ' : ' + IntToStr(iTotalCnt - iWorkCnt);
        PnMsg1.Caption := ' : ' + IntToStr(iWorkCnt);
        PnMsg3.Font.Color := clBlue;
        PnMsg3.Caption := '';
      end
      else begin
        PnMsg3.Font.Color := clRed;
        PnMsg3.Caption := '۾Ϸ';
      end;

      if GetMinMaxMtNo(sOnCd, sDate, sAncd, iRvNo) = true then begin
        PnJiStNo.Caption := IntToStr(iMinMtNo);
        PnJiEdNo.Caption := IntToStr(iMaxMtNo);
      end
      else begin
        PnJiStNo.Caption := '0';
        PnJiEdNo.Caption := '0';
      end;

      except on E: EDbEngineError do begin   // ڷ  
        ShowMessage('ڷ Դϴ! Ȯϼ' + ' ' + E.Errors[0].Message);
        DataBase.Rollback;
        pnMsg1.Caption := ' : ' + IntToStr(iWorkCnt - 1);
        pnMsg2.Caption := ' : ' + IntToStr(iTotalCnt + 1);
        PnMsg3.Font.Color := clRed;
        PnMsg3.Caption := '';
        exit;
      end;
    end;
  end;
end;

//ȣ ȣ ± ̺ ϴ ϸ Update
procedure TfrmPig_F.DataExCheck;
var
  sRvNo, sMtNo, sDate : String;
begin
  sRvNo := Trim(PnNo.Caption);    // ȣ
  sMtNo := Trim(PnJiNo.Caption);  // ȣ
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' select kill_ymd, receive_no, mt_no from auctag ' +
            ' where online_cd  = :oncd             ' +
            '   and kill_ymd   = :ymd              ' +
            '   and animal_cd  = :ancd             ' +
            '   and receive_no = :rvno             ' +
            '   and mt_no      = :mtno             ' );
    ParamByName('oncd').AsString := sOnCd;
    ParamByName('ymd' ).AsString := sDate;
    ParamByName('ancd').AsString := sAnCd;
    ParamByName('rvno').AsInteger := StrToint(sRvNo);
    ParamByName('mtno').AsInteger := StrToInt(sMtNo);
    Open;
    if not eof then begin
      with QryTemp1 do begin
        Close;
        Sql.Clear;
        Sql.Add(' update auctag                       ' +
                '    set kill_ymd = null,             ' +
                '        receive_no = null,           ' +
                '        mt_no      = null            ' +
                '  where online_cd = :oncd            ' +
                '    and kill_ymd = :ymd              ' +
                '    and animal_cd  = :ancd           ' +
                '    and receive_no = :rvno           ' +
                '    and mt_no      = :mtno           ');
        ParamByName('oncd').AsString := sOnCd;
        ParamByName('ymd' ).AsString := sDate;
        ParamByName('ancd').AsString := sAnCd;
        ParamByName('rvno').AsInteger := StrToInt(sRvNo);
        ParamByName('mtno').AsInteger := StrToInt(sMtNo);
//        PrePare;
        ExecSql;
        close;
      end;
      close;
    end;
  end;
end;

procedure TfrmPig_F.InsertAucTag;
var
  sRvNo, sMtNo, sDate, sInputGb, supmtno, sTag_No : String;
  dDate : TDateTime;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  sRvNo := Trim(PnNo.Caption);    // ȣ
  sMtNo := Trim(PnJiNo.Caption);  // ȣ
  sTag_No := Trim(edTagNo.Text);   // ±׹ȣ
  dDate := udGetSysDate;
  sInputGb := 'I';  // T:± H:
  If sRvNo <> '' Then Begin
  if sMtNo <> '' then begin
     With QryTemp Do Begin
       Close;
       Sql.Clear;
       Sql.Add('select online_cd, tag_no, mt_no from auctag     ' +
               ' where online_cd  = :oncd                       ' +
               '   and tag_no     = :tag_no                     ');
       ParamByName('tag_no').AsString  := sTag_No;
       ParamByName('oncd'  ).AsInteger := StrToInt(sOnCd);
       Open;
       If Not Eof Then begin
         supmtno := IntToStr(FieldByName('mt_no').AsInteger);
         with QryTemp1 do begin
             Close;
             Sql.Clear;
             Sql.Add('update auctag                     ' +
                     '   set kill_ymd  = :ymd,          ' +
                     '       animal_cd = ''2'',         ' +
                     '       mt_no     = :mtno,         ' +
                     '       receive_no = :rvno,        ' +
                     '       lr_gb     = ''1'',         ' +
                     '       weight    = 0    ,         ' +
                     '       trans_dt  = null ,         ' +
                     '       trans_gb  = ''0'',         ' +
                     '       oper_dt   = :operdt,       ' +
                     '       oper_nm   = :opernm,       ' +
                     '       input_gb  = :inpgb,        ' +
                     '       true_mt_no = :mtno,        ' +
                     '       err_text   = null          ' +
                     ' where online_cd = :oncd          ' +
                     '   and tag_no    = :tag_no        ');
             ParamByName('ymd'   ).AsString   := sDate;
             ParamByName('mtno'  ).AsInteger  := StrToInt(sMtNo);
             ParamByName('rvno'  ).AsInteger  := StrToInt(sRvNo);
             ParamByName('operdt').AsDateTime := dDate;
             ParamByName('opernm').AsString   := gsUserName;
             ParamByName('inpgb' ).AsString   := sInputGb;
             ParamByName('tag_no').AsString   := sTag_No;
             ParamByName('oncd'  ).AsInteger  := StrToInt(sOnCd);
//             PrePare;
             ExecSql;
             close;
             serr_text := 'update : ' + sUpMtNo;  // update   ȣ ǥ
         end;
       End
       Else Begin
         with QryTemp1 do begin
           Close;
           Sql.Clear;
           Sql.Add('Insert Into auctag                                           ' +
                   ' (online_cd, tag_no, kill_ymd, animal_cd, mt_no, receive_no, ' +
                   '  lr_gb, oper_dt, oper_nm, input_gb,                         ' +
                   '  weight, trans_dt, trans_gb, true_mt_no, err_text )         ' +
                   'values (:oncd, :tag_no, :ymd, :ancd, :mtno, :rvno,           ' +
                   '  ''1'', :opdt, :opnm, :iptgb,                               ' +
                   '  0, null, ''0'', :mtno, null )                             ' );
           ParamByName('oncd'  ).AsInteger  := StrToInt(sOnCd);
           ParamByName('tag_no').AsString   := sTag_No;
           ParamByName('ymd'   ).AsString   := sDate;
           ParamByName('mtno'  ).AsInteger  := StrToInt(sMtNo);
           ParamByName('rvno'  ).AsInteger  := StrToInt(sRvNo);
           ParamByName('ancd'  ).AsString   := sAnCd;
           ParamByName('opdt'  ).AsDateTime := dDate;
           ParamByName('opnm'  ).AsString   := gsUserName;
           ParamByName('iptgb' ).AsString   := sInputGb;
//           prepare;
           ExecSql;
           close;
           serr_text := 'insert : ' + sMtNo; // insert   ȣ insert
         end;
         close;
       End;
     End;
  end
  else begin
     ShowMessage('ȣ ԷϽʽÿ!');
     exit;
  end;    // if smtno <> '' end.
  End
  Else Begin
     ShowMessage('ȣ ԷϽʽÿ!');
     exit;
  End;   // if srvno <> ''  end.
end;

procedure TfrmPig_F.InsertAucLogTag;
var
  sDate, sRvNo, sMtNo,sTag_No, sInputGb : String;
  dDate : TDateTime;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);
  sRvNo := Trim(PnNO.Caption);
  sMtNo := Trim(PnJiNo.Caption);  // ȣ
  sTag_No := Trim(edTagNo.Text);
  dDate := udGetSysDate;
  sInputGb := 'I';  // T:± H:
  with QryTemp do begin
    Close;
    Sql.Clear;
    Sql.Add(' insert into auclogtag                                            ' +
            ' (online_cd, tag_no, trans_dt, kill_ymd, mt_no, receive_no,       ' +
            '  animal_cd, lr_gb, oper_id, input_gb, log_gb, true_mt_no, err_text )' +
            ' values (:oncd, :tagno, :trsdt, :ymd, :mtno, :rvno,               ' +
            '         :ancd, :lrgb, :operid, :inpgb, :loggb, :mtno, :err_txt)  ' );
    ParamByName('oncd'  ).AsInteger  := StrToInt(sOnCd);
    ParamByName('tagno' ).AsString   := sTag_No;
    ParamByName('trsdt' ).AsDateTime := dDate;
    ParamByName('ymd'   ).AsString   := sDate;
    ParamByName('ancd'  ).AsString   := sAnCd;
    ParamByName('lrgb'  ).AsString   := '1';
    ParamByName('mtno'  ).AsInteger  := StrToInt(sMtNo);
    ParamByName('rvno'  ).AsInteger  := StrToInt(sRvNo);
    ParamByName('operid').AsString   := gsUserId;
    ParamByName('inpgb' ).AsString   := sInputGb;
    ParamByName('loggb' ).AsString   := 'I';
    ParamByName('err_txt').AsString  := sErr_Text;
//    PrePare;
    ExecSql;
    close;
  end;
end;

procedure TfrmPig_F.SerialInit;
begin
  TimeCnt := 0;
  TmConnect.Interval := iLampTime;
  TmConnect.Enabled := True;
  SendPacket(CMD_STATE, ID_CONTROLLER, [$00], 0);
end;

procedure TfrmPig_F.CmPtRxChar(Sender: TObject; Count: Integer);
var
  Cnt, i : Integer;
  TmpBuf : array[0..MAX_SIZE-1] of Byte;
begin
  Cnt := 0;
  FillChar(TmpBuf, MAX_SIZE, $00);
  Cnt := CmPt.Read(TmpBuf, Count);
  if(Cnt <= 0) then Exit;

  if TimeCnt <= 3 then begin
     Shape1.Pen.Color := clGreen;
     TmConnect.Enabled := False;
     TimeCnt := 0;
  end;

  for i:=0 to Cnt-1 do
  begin
    case TmpBuf[i] of
      _STX:
        begin
          pIdx:= 0;
          pBuf[pIdx] := _STX;
          Inc(pIdx);
        end;
      _ETX:
        begin
          pBuf[pIdx] := _ETX;
          Inc(pIdx);
        end;
      else
        begin
          pBuf[pIdx] := TmpBuf[i];
          inc(pIdx);

          if(pIdx >= MAX_SIZE) then
          begin
            pIdx := 0;
          end else if((pIdx > 2) and (pBuf[pIdx-2] = _ETX)) then
          begin
            NotificationHandler(pBuf, pIdx);
            pIdx := 0;
          end;
        end;
    end; // case..end
  end;
end;

function TfrmPig_F.SendPacket(cmd, id: byte; buf: array of byte;
            len: Integer): Integer;
var
  i,x: integer;
  bcc: byte;
  tx: array[0..250] of byte;
begin
  Result:= 0;
  if not CmPt.Connected then  Exit;

  x:= 0;
  tx[x]:= _STX;   Inc(x);
  tx[x]:= cmd;    Inc(x);
  tx[x]:= id;     Inc(x);

  move(buf, tx[x], len);
  Inc(x, len);

  tx[x]:= _ETX;   Inc(x);

  bcc:= 0;
  for i:=0 to x-1 do
    bcc:= bcc xor tx[i];
  bcc:= bcc or $80;

  if(bcc = $FF) then
    bcc:= $7F;

  tx[x]:= bcc;      Inc(x);
  // Send
  Result:= CmPt.Write(tx, x);

  if(Result > 0) then
  begin
//    showmessage(Format('SEND[%0.2d]: %s', [x, ArrayToString(tx,x)]));
  end else begin
//    showmessage('SEND FAIL...');
  end;
end;

procedure TfrmPig_F.NotificationHandler(buf: array of byte; cnt: Integer);
var
  i, ii, jj: integer;
  bcc: byte;
  AckNak: byte;
  p, p1: PChar;
begin
  ii := 0;
  bcc:= $00;
  // cnt-1 : bcc
  // cnt-2 : etx
  // bcc: <stx> ~ <etx>
  for i:=0 to cnt-2 do begin
    bcc:= bcc xor buf[i];
  end;

  bcc:= bcc or $80;
  if(bcc = $FF) then bcc:= $7F;

  if(bcc = buf[cnt-1]) then begin
    AckNak:= _ACK;
  end else begin
    AckNak:= _NAK;
    Exit;
  end;

  case buf[1] of        // cmd
    CMD_STATE: // Controller Init
      begin
        if cnt = 5 then begin // CMD
          Shape1.Pen.Color := clGreen;
          SendPacket(CMD_STATE, ID_CONTROLLER, [AckNak], 1);
        end;
      end;
    CMD_READER :
      begin
        p := PChar(@buf[0]);
        p := StrPos(p, ':');
        if(p = nil) then begin
          Exit;
        end;

        inc(p);
        p1 := StrPos(p, ':');
        if(p1 = nil) then begin
          Exit;
        end;

        if (p1 - p) <> 11 then begin
          exit;
        end;

        p[11] := #0;

        sTagNo := strpas(p);
//        if ((sTagNo = Trim(edTagNo.Text)) or (Trim(edTagNo.Text) = '')) then begin
          edTagNo.Text := sTagNo;
          if length(sTagNo) = 11 then begin
            Shape1.Pen.Color := clBlue;
            Shape1.Pen.Color := clYellow;
            PnMsg3.Caption := '';
            PnMsg3.Font.Color := clRed;
            SendPacket(CMD_LAMP, ID_LAMP, [LP_BLUE], 1);
          end
          else if ((length(sTagNo) > 0) and (length(sTagNo) < 11)) then begin
              PnMsg3.Font.Color := clRed;
              PnMsg3.Caption := '±׿';
              SendPacket(CMD_LAMP, ID_LAMP, [LP_RED], 1);
          end else exit;

          TimeCnt := 0;
          TmLamp.Interval := iLampTime;
          TmLamp.Enabled := True;
//        end;
        SendPacket(CMD_READER, ID_READER, [AckNak], 1);
      end;

    CMD_LAMP:
      begin
        if cnt = 5 then begin// CMD
          SendPacket(CMD_LAMP, ID_LAMP, [AckNak], 1);
        end;
      end;
    CMD_LIMIT:
      begin
        SendPacket(CMD_LIMIT, ID_LIMIT, [AckNak], 1);

        if length(sTagNo) <> 11 then begin
          Shape1.Pen.Color := clRed;
          SendPacket(CMD_LAMP, ID_LAMP, [LP_RED], 1);
          TimeCnt := 0;
          TmLamp.Interval := iLampTime;
          TmLamp.Enabled := True;
        end
        else if length(sTagNo) = 11 then begin
          if dupCheck(sTagNo) = true then begin
            FiFo(tagBuf[tagCnt], sTagNo);
            btnSav.Click;
            Shape1.Pen.Color := clBlue;
            SendPacket(CMD_LAMP, ID_LAMP, [LP_BLUE], 1);
            TimeCnt := 0;
            TmLamp.Interval := iLampTime;
            TmLamp.Enabled := True;
          end
          else begin
            PnMsg3.Caption := '';
            PnMsg3.Font.Color := clBlue;
          end;
        end;
        sTagNo := '';
        edTagNo.Text := '';
        FillChar(pbuf, MAX_SIZE, $00);
        pidx := 0;
        end;
    CMD_ERROR:
      begin
        showmessage('Ʈѷ κҸ, ߻. Ʈѷ Ͻʽÿ!');
      end;
    else
      begin
        //
      end;
  end;
end;

procedure TfrmPig_F.FiFo(buf:array of String; in_tagno : String);
var
  i : integer;
begin
//  showmessage('0:'+tagbuf[0]+' : '+'1:'+tagbuf[1]+' : '+'2:'+tagbuf[2]+' : '+'3:'+tagbuf[3]+' : '+'4:'+tagbuf[4]+' : '
//              +'5:'+tagbuf[5]+' : '+'6:'+tagbuf[6]+' : '+'7:'+tagbuf[7]+' : '+'8:'+tagbuf[8]+' : '+'9:'+tagbuf[9]);
  for i:=0 to tagCnt do begin
    if tagBuf[i] = in_tagno then begin  //      exit
       exit;
    end;
  end;

  tagBuf[tagCnt] := in_tagno;

  tagCnt := TagCnt + 1;
  if tagCnt > 9 then begin
    for i:=0 to tagCnt-1 do begin
      tagBuf[i] := '';
      if i < 9 then begin
        tagBuf[i] := tagBuf[i+1];
      end;
    end;
    tagCnt := 9;
  end;
//  showmessage('0:'+tagbuf[0]+' : '+'1:'+tagbuf[1]+' : '+'2:'+tagbuf[2]+' : '+'3:'+tagbuf[3]+' : '+'4:'+tagbuf[4]+' : '
//              +'5:'+tagbuf[5]+' : '+'6:'+tagbuf[6]+' : '+'7:'+tagbuf[7]+' : '+'8:'+tagbuf[8]+' : '+'9:'+tagbuf[9]);
end;

function TfrmPig_F.dupCheck(in_tagno : String) : Boolean;
var
  i : integer;
begin
  for i:=0 to tagCnt do begin
    if tagBuf[i] = in_tagno then begin
      result := false;
      exit;
    end
    else begin
      result := true;
    end;
  end;
end;

function TfrmPig_F.ArrayToString(buf: array of byte; len: Integer): string;
var
  i: Integer;
begin
  result:= '';
  for I:=0 to (len-1) do
    result:= result + IntToHex(buf[i],2) + ' ';
end;

procedure TfrmPig_F.tmConnectTimer(Sender: TObject);
begin
  inc(TimeCnt);
  if TimeCnt > 3 then begin
     TmConnect.Enabled := False;
     TimeCnt := 0;
     shape1.Pen.Color := clWhite;
     showmessage('Ʈѷ ¸ ȮϽʽÿ!');
     exit;
  end;
end;

procedure TfrmPig_F.tmLampTimer(Sender: TObject);
begin
  inc(TimeCnt);
  if TimeCnt > 0 then begin
    SendPacket(CMD_LAMP, ID_LAMP, [LP_OFF], 1);
    TmLamp.Enabled := False;
    TimeCnt := 0;
    exit;
  end;
end;

procedure TfrmPig_F.Image1Click(Sender: TObject);
begin
    PortChk;
    SerialInit;
end;

procedure TfrmPig_F.dtdateChange(Sender: TObject);
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);

  if GetMinMaxRvNo(sOnCd, sDate, sAnCd) then begin
    PnStNo.Caption := IntToStr(iMinRvNo);
    PnEdNo.Caption := IntToStr(iMaxRvNo);
  end
  else begin
    PnStNo.Caption := '0';
    PnEdNo.Caption := '0';
  end;

  iTotalCnt := GetTotalCnt;
  iWorkCnt  := GetInputCnt;
  PnMsg2.Caption := ' : ' + IntToStr(iTotalCnt - iWorkCnt);
  PnMsg1.Caption := ' : ' + IntToStr(iWorkCnt);
end;

procedure TfrmPig_F.Panel12DblClick(Sender: TObject);
begin
  inc(iClickCnt);
  if iClickCnt = 10 then begin
    edTagNo.Text := '';
    sTagNo := '';
    iClickCnt := 0;
    PnMsg3.Font.Color := clBlue;
    PnMsg3.Caption := '';
  end;
end;

procedure TfrmPig_F.Panel12Exit(Sender: TObject);
begin
  iClickCnt := 0;
end;

procedure TfrmPig_F.pnNoDblClick(Sender: TObject);
begin
  iFlag := 1;
  PnNo.Caption := '';
  PnNo.Color := $006FE6B0;
  PnJiNo.Color := ClWhite;
  PnDonPi.Color := ClWhite;
end;

procedure TfrmPig_F.pnJiNoDblClick(Sender: TObject);
var
  sDate : String;
begin
  DateTimeToString(sDate, 'YYYY-MM-DD', DtDate.Date);

  iFlag := 2;
  PnJiNo.Caption := '';
  PnNo.Color := ClWhite;
  PnDonPi.Color := ClWhite;
  PnJiNo.Color := $006FE6B0;
  if ((Trim(PnNo.Caption) = '') or (Trim(PnNo.Caption) = '0')) then begin
  end
  else begin
    iRvNo := StrToInt(Trim(PnNo.Caption));
    if GetMinMaxMtNo(sOnCd, sDate, sAncd, iRvNo) = true then begin
       PnJiStNo.Caption := IntToStr(iMinMtNo);
       PnJiEdNo.Caption := IntToStr(iMaxMtNo);
    end
    else begin
       PnJiStNo.Caption := '0';
       PnJiEdNo.Caption := '0';
    end;
  end;
end;

procedure TfrmPig_F.PnDonPiDblClick(Sender: TObject);
begin
  iFlag := 3;
  PnDonPi.Caption := '';
  PnNo.Color    := ClWhite;
  PnJiNo.Color  := ClWhite;
  PnDonPi.Color := $006FE6B0;
end;

end.

