unit TchLib;

interface

uses Windows,SysUtils, dbtables, Classes, IniFiles, Math,Forms,MMSystem,
     Messages,Graphics, Controls,StdCtrls,ComCtrls;
var
    gv_MyList : TStringList;

Function udAppJustOne:Boolean;// ȭ ѹ (ߺ)
Function udIdchk(Var strId : String) : Boolean;
Function udPwdchk(Var strId, strPwd : String) : Boolean;
function udGetSysDate : TDateTime;
procedure udGetDate;

function gf_PubQry(Qry_Text:String): Integer;        // ޾Ƽ   recordCount 


implementation

Uses DM_F, DB;


Function udAppJustOne:Boolean;// ȭ ѹ (ߺ)
Var zAppName: array[0..60] of char;
    MH:THandle;
begin
  StrPCopy(zAppName, ExtractFileName(ParamStr(0)));
  MH:= CreateMutex(nil, TRUE, zAppName);
  If MH <> 0 then
  Begin
    If GetLastError = ERROR_ALREADY_EXISTS Then
    Begin
      udAppJustOne:= TRUE;
      CloseHandle(MH);
    End
    Else udAppJustOne:= FALSE;
  End
  Else   udAppJustOne:= FALSE;
End;

Function udIdChk(Var strId : String) : Boolean;
var qryTemp : TQuery;
Begin
  qryTemp := Nil;
  Try
    qryTemp := TQuery.Create(nil);
    qryTemp.DatabaseName := 'auc';
    With qryTemp Do
    Begin
      Close;
      Sql.Clear;
      Sql.Add('select per_class, per_cd, per_nm, per_sec from aucperson ' +
              ' where per_cd = :per_cd                                  ');
      ParamByName('per_cd').AsString := strId;
      Open;
      If Not Eof then
        Result := true
      else
        Result := false;
    End;
  Except
    qryTemp.Free;
    Result := False;
  End;
End;

Function udPwdChk(Var strId, strPwd : String) : Boolean;
var qryTemp : TQuery;
Begin
  qryTemp := Nil;
  Try
    qryTemp := TQuery.Create(nil);
    qryTemp.DatabaseName := 'auc';
    With qryTemp Do
    Begin
      Close;
      Sql.Clear;
      Sql.Add('select per_class, per_cd, per_nm, per_sec from aucperson ' +
              ' where per_cd  = :per_cd                                 ' +
              '   and per_sec = :per_sec                                ');
      ParamByName('per_cd').AsString := strId;
      ParamByName('per_sec').AsString := strPwd;
      Open;
      If Not Eof then begin
        gsUserID   := FieldByName('per_cd').AsString;
        gsUserName := FieldByName('per_nm').AsString;
        Result := true;
      end
      else
        Result := false;
    End;
  Except
    qryTemp.Free;
    Result := False;
  End;
End;

procedure udGetDate;
var
  qryTemp : TQuery;
begin
  qryTemp := Nil;
  Try
    qryTemp := TQuery.Create(Nil);
    qryTemp.DataBaseName := 'auc';
    with qrytemp do begin
      Close;
      Sql.Clear;
      Sql.Add(' select getdate() sysdate ');
      Open;
      if Not Eof then begin
         gdDate := FieldByName('sysdate').AsDateTime;
      end
      else begin
         gdDate := StrToDate('1900-00-00');
      end;
    end;
  Except
    qryTemp.Free;
  end;
end;

function udGetSysDate : TDateTime;
var
  qryTemp : TQuery;
  dDate : TDateTime;
begin
  qryTemp := Nil;
  Try
    qryTemp := TQuery.Create(Nil);
    qryTemp.DataBaseName := 'auc';
    with qrytemp do begin
      Close;
      Sql.Clear;
      Sql.Add(' select getdate() sysdate ');
      Open;
      if Not Eof then begin
         dDate := FieldByName('sysdate').AsDateTime;
      end
      else begin
         dDate := StrToDate('1900-00-00');
      end;
      result := dDate;
    end;
  Except
    qryTemp.Free;
  end;
end;

function gf_PubQry(Qry_Text:String): Integer;
var
  i: Integer;
  pub_qry : TQuery;
begin
  pub_qry := nil;
  Try
  gv_MyList.Clear;
  pub_qry := TQuery.Create(nil);
  pub_qry.DatabaseName := 'auc';
  With pub_qry do begin
    Close;
    SQL.Clear;
    SQL.Add(Qry_Text);
    Open;
    First;
    While Not Eof do begin
      For i := 0 to Fields.Count -1 do
         gv_MyList.Add(Fields[i].AsString);
      Next;
    end;
    Result := RecordCount;
    Close;
    Free;
  end;
  Except
    pub_qry.close;
    pub_qry.Free;
    Result := pub_qry.RecordCount;
    Exit;
  end;
end;

end.
